// RTTYAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RTTYApp.h"
#include "RTTYAppDlg.h"
#include "RTTYSchedule.h"
//#include "wa9xhnbuild.h"
#include "defines.h"
#include "codes.h"  //Only needed LTRS for wdelay function
#include "morse.h"
#include <stdlib.h>
#include <sys/types.h>
#include <windows.h>
#include <conio.h>
#include <time.h>
#include <math.h>
#include <sys/types.h>
#include <sys/timeb.h>

#include "PskCoreImplicit.h"
#include "Sound/ProcThread.h"
#include "Sound/Sound.h"

#include <process.h>

#include "officialcallsign.h" // file for setting officila BUILD callsign

#include "Telnet.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COLOR RGB(0,255,255)
#define OK 0
#define GOOD 0
#define BAD 1
#define MAXSIZE 32000
#define BF_UNCHECKED 0
#define BF_CHECKED 1
#define BF_GRAYED  2
#define LTRS 31	  /* Baudot LTRS character and case machine state */
#define CWTIMER 3600
//#define IDLE_STATE  -9
#define TXOFF_CODE -1			// control codes that can be placed in the input
#define TXON_CODE -2			// queue for various control functions
#define TXTOG_CODE -3

/* DEFINE MODE */
enum mode {    // not quite global, defined in main
    ascii,
	ita2,
	telex,
    military,
	psk31,
	morse
};


char CWidString[60] = "";
char AboutBoxString[50] = "";
char WideCallsign[45] = "";

// Nasty Globals
char longdash[] = "-------------------------------------------";
int COMPORT;
float BAUD = (float)45.45;
const int TxRTS = 0x02;
const int TxDTR = 0x01;
int TxLine = TxDTR;
int PowerLine = TxRTS;
int MODE = military;   // global only in progmanx, redefined in rs-232.cpp
int DATABITS;
int timerTick = 0;
int morseTick = 0;
int CWTimer = -1;  // intitalized as not enabled
int scheduleEnable;
int transferCancel;
int notSending = TRUE;
int transferSend;
int setRepeat;
int sendNow;
int localLock;
int headerEnable;
int diddleEnable = FALSE;
int transmitOn = FALSE;
int CalcMSK_TX_char[100];

HWND AddDlg_hWnd;
CRTTYAppDlg * m_RTTYAppDlg;


int WM_MSGPORT00;
int WM_MSGPORT01;

extern char listboxtext[256];
int tt_queue; // global time used in availability
int sizeofcommands = 34;
int deltacommands = 2;
char * com[] = 
{
    "Edit",
	"COM1",
	"COM2",
	"COM3",
	"COM4",
	"COM5",
	"COM6",
	"COM7",
	"COM8",
	"????"
};

char * commands[] = 
{
"$-- --------------------------------------",
"$RX       // Transmitter OFF",
"$TX       // Transmiter ON",
"$PON      // Power ON",
"$POFF     // Power OFF",
"$ASCII    // MODE = ASCII",
"$MILITARY // MODE = MILITARY",
"$ITA2     // MODE = ITA2",
"$TELEX    // MODE = TELEX",
"$PSK31    // MODE = PSK31",
"$PSK=xxx.x// Set PSK Center Freq",
"$CW       // MODE = real CW",
" ",	// index 12 blank line
"$CWTimer  // Starts 1 Hour CW ID",
"$CWStop   // Stops  1 Hour CW ID",
"$B45      // BAUD = 45.45",
"$B50      // BAUD = 50.0",
"$B56      // BAUD = 56.9",
"$B74      // BAUD = 74.4",
"$B100     // BAUD = 100.0",
"$B110     // BAUD = 110.0",
"$B300     // BAUD = 300.0",
"$FSK=xxx.x// Set FSK Center Freq",
"$F1500    // PSK Freq = 1500",
"$F1600    // PSK Freq = 1600",
"$F1700    // PSK Freq = 1700",
"$F1800    // PSK Freq = 1800",
"$F1900    // PSK Freq = 1900",
"$F2000    // PSK Freq = 2000",
"$F2100    // PSK Freq = 2100",
"$RELOAD   // Reload Script",
"$HEADER   // Send Header/Footer",
"$NOHEADER // No Header/Footer",
"$DITTLE   // George's Dittle",
"$NODITTLE // No Dittle",
"$DISABLE  // Disable AutoSend",
"$COM1     // Comport = 0x3F8",
"$COM2     // Comport = 0x2F8",
"$COM3     // Comport = 0x3E8",
"$COM4     // Comport = 0x3E0",
"$COM5     // Comport = 0x2F0",
"$COM6     // Comport = 0x2E8",
"$COM7     // Comport = 0x2E0",
"$COM8     // Comport = 0x260",
// Special commands don't show up in list
"$RTS      // Debug Only : Use RTS for XMIT",
"$DTR      // Debug Only : Use DTR for XMIT"
};



// Function Prototypes
//int xmitchar(int ch);
//void send_baudot(int ch1, int MODE);
//////void GiveUp();
//void OpenCom(int COMPORT,
//     float baud,
//      int parity,
//      int databits,
//      int stopbits);
// Telnet Extras
Telnet * m_pConnectSocket;
// Sound Card Extras
CProcThread* vpProcThread;
CRITICAL_SECTION vCriticalSection;	// use for keeping threads
extern BOOL m_fProcThreadQuit;
bool CalcMSK_BuffEmpty	= true;
float psk_freq			= 1500.0;
float psk_shift			= 31.25;
float fsk_freq			= 2210.0;
float fsk_shift			= 170.0;

#include <ctype.h> // _isascii

// Outside Post message stuff
BOOL xPostMessage( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
{
	int status = 0;
//	status = PostMessage(hWnd, Msg, wParam, lParam );	// eats resources
//	status = SendMessage(hWnd, Msg, wParam, lParam );	// W98 friendly
	if (m_pConnectSocket->m_NetStatus == NET_CONNECTED)
	{
		if (__isascii(wParam))
			m_pConnectSocket->Send(&wParam,1);
	}

	return status;	

} 
 


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListBox	AboutListBox;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_ABOUT, AboutListBox);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTTYAppDlg dialog

CRTTYAppDlg::CRTTYAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRTTYAppDlg::IDD, pParent)
{	
	//{{AFX_DATA_INIT(CRTTYAppDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pRTTYSchedule = NULL;
//	m_pParent = pParent;
}

void CRTTYAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTTYAppDlg)
	DDX_Control(pDX, IDC_EDITAUTHENTICATION, m_EditAuthentication);
	DDX_Control(pDX, IDC_COMBOSOUNDCARD, m_ComboSoundCard);
	DDX_Control(pDX, IDC_CHECKNOSOUNDCARD, m_CheckNoSoundCard);
	DDX_Control(pDX, IDC_EDITIPADDRESS, m_EditIPAddress);
	DDX_Control(pDX, IDC_COMBOIP, m_ComboIP);
	DDX_Control(pDX, IDC_RADIOFREQ1, m_RadioFreq1);
	DDX_Control(pDX, IDC_EDITSHIFT, m_EditShift);
	DDX_Control(pDX, IDC_EDITPSKFREQ, m_EditPSKFreq);
	DDX_Control(pDX, IDC_EDITSPACE, m_EditSpace);
	DDX_Control(pDX, IDC_EDITMARK, m_EditMark);
	DDX_Control(pDX, IDC_BAUD, m_BaudGroup);
	DDX_Control(pDX, IDC_MODE, m_ModeGroup);
	DDX_Control(pDX, IDC_74, m_B74);
	DDX_Control(pDX, IDC_56, m_B56);
	DDX_Control(pDX, IDC_300, m_B300);
	DDX_Control(pDX, IDC_110, m_B110);
	DDX_Control(pDX, IDC_100, m_B100);
	DDX_Control(pDX, IDC_50, m_B50);
	DDX_Control(pDX, IDC_45, m_B45);
	DDX_Control(pDX, IDC_POWER, PowerON);
	DDX_Control(pDX, IDC_CWTIMERDISPLAY, CWTimerDisplay);
	DDX_Control(pDX, IDC_CWTIMER, CWTimerCheck);
	DDX_Control(pDX, IDC_COMPORT, ComPort);
	DDX_Control(pDX, IDC_SLIDER, Slider);
	DDX_Control(pDX, IDC_DIDDLE, Diddle);
	DDX_Control(pDX, IDC_FILELIST, FileList);
	DDX_Control(pDX, IDC_HEADER, Header);
	DDX_Control(pDX, IDC_SENDQUEUEBOX, SendQueueBox);
	DDX_Control(pDX, IDC_REPEAT, Repeat);
	DDX_Control(pDX, IDC_CANEDIT, CanEdit);
	DDX_Control(pDX, IDC_COUNTDOWNBOX, CountDownBox);
	DDX_Control(pDX, IDC_AUTOSENDBOX, AutoSendBox);
	DDX_Control(pDX, IDC_TRANSMITBOX, TransmitBox);
	DDX_Control(pDX, IDC_EDITSAVEBOX, EditSaveBox);
	DDX_Control(pDX, IDC_EDITDISPLAY, EditDisplay);
	DDX_Control(pDX, IDC_QUEUEBOX, QueueBox);
	DDX_Control(pDX, IDC_FLOWCONTROLBOX, FlowControlBox);
	DDX_Control(pDX, IDC_CLOCKBOX, ClockBox);
	DDX_Control(pDX, IDC_SENDINGBOX, SendingBox);
	DDX_Control(pDX, IDC_LISTBOX, ListBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRTTYAppDlg, CDialog)
	//{{AFX_MSG_MAP(CRTTYAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MODE, OnMode)
	ON_BN_CLICKED(IDC_SENDNEXT, OnSendnext)
	ON_BN_CLICKED(IDC_RELOAD, OnReload)
	ON_LBN_DBLCLK(IDC_LISTBOX, OnDblclkListbox)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_45, OnB45)
	ON_BN_CLICKED(IDC_50, OnB50)
	ON_BN_CLICKED(IDC_56, OnB56)
	ON_BN_CLICKED(IDC_74, OnB74)
	ON_BN_CLICKED(IDC_100, OnB100)
	ON_BN_CLICKED(IDC_110, OnB110)
	ON_BN_CLICKED(IDC_MILITARY, OnModeMilitary)
	ON_BN_CLICKED(IDC_ITA2, OnModeIta2)
	ON_BN_CLICKED(IDC_TELEX, OnModeTelex)
	ON_BN_CLICKED(IDC_ASCII, OnModeAscii)
	ON_BN_CLICKED(IDC_RYRYRY, OnRyryry)
	ON_BN_CLICKED(IDC_REPEAT, OnRepeat)
	ON_BN_CLICKED(IDC_DISABLE, CmDisable)
	ON_BN_CLICKED(IDC_ENABLE, CmEnable)
	ON_BN_CLICKED(IDC_PAUSE, CmPause)
	ON_BN_CLICKED(IDC_RESUME, CmResume)
	ON_BN_CLICKED(IDC_CANCEL, CmCancel)
	ON_BN_CLICKED(IDC_CANEDIT, OnCanEdit)
	ON_BN_CLICKED(IDC_ON, CmTX)
	ON_BN_CLICKED(IDC_OFF, CmRX)
	ON_BN_CLICKED(IDC_THEFOX, OnThefox)
	ON_BN_CLICKED(IDC_EVENTLOG, OnEventlog)
	ON_BN_CLICKED(IDC_DELETE, OnDeleteItem)
	ON_BN_CLICKED(IDC_ADD, OnAddItem)
	ON_BN_CLICKED(IDC_COMPOSE, OnCompose)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_HEADER, OnHeader)
	ON_BN_CLICKED(IDC_MORSE, OnModeMorse)
	ON_BN_CLICKED(IDC_FILEADD, OnFileadd)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_FILELIST, OnSelchangeFilelist)
	ON_BN_CLICKED(IDC_DIDDLE, OnDiddle)
	ON_BN_CLICKED(IDC_CWTIMER, OnCWTimer)
	ON_BN_CLICKED(IDC_POWER, OnPower)
	ON_BN_CLICKED(IDC_BUTTONSENDCWID, OnButtonsendcwid)
	ON_BN_CLICKED(IDC_RADIOPSK31, OnModePSK31)
	ON_BN_CLICKED(IDC_RADIOFREQ1, OnRadiofreq1)
	ON_BN_CLICKED(IDC_RADIOFREQ2, OnRadiofreq2)
	ON_BN_CLICKED(IDC_CHECKNOSOUNDCARD, OnChecknosoundcard)
	ON_CBN_EDITCHANGE(IDC_COMBOSOUNDCARD, OnEditchangeCombosoundcard)
	ON_BN_CLICKED(IDC_300, OnB300)
	ON_CBN_SELCHANGE(IDC_COMBOSOUNDCARD, OnSelchangeCombosoundcard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTTYAppDlg message handlers

BOOL CRTTYAppDlg::OnInitDialog()
{
	char temp[80];
	char port[10] = "2";
	char txline[10] = "";
//	int count;
	RTTYSchedule dlgAbout;
	unsigned int i;
	int status;

	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	ASSERT((IDM_DIALOGEDITOR & 0xFFF0) == IDM_DIALOGEDITOR);
	ASSERT(IDM_DIALOGEDITOR < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		CString strSchedulerMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		strSchedulerMenu.LoadString(IDS_SCHEDULERBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			pSysMenu->AppendMenu(MF_STRING, IDM_DIALOGEDITOR, strSchedulerMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Read Command Line Parameters
	// Initialize ComPort settings
	COMPORT = 0x2F8;  // Default Com2
	DATABITS = d5;    // Default 5-Bit data
	MODE = military;  // Default Military Mode
	char * inputstring;
	char callsign[15] = "None";

	// Get the Command Line
	inputstring = GetCommandLine();

	// Shift everything to Upper Case
	for (i=0; i<strlen(inputstring); i++)
	{
		inputstring[i] = toupper(inputstring[i]);
	}

	// Eliminate the first parameter
	inputstring = strrchr(inputstring,'"') + 1;

	// Set up the control parameters
	status = sscanf(inputstring,"%s %s %s %s", callsign,port,txline,temp);
	switch (status)
	{
	case 3:// Third Parameter
		// Set the RTS/DTR Line Control
		if (strncmp(txline,"DTR",3) == 0)
			TxLine = TxDTR;
		if (strncmp(txline,"RTS",3) == 0)
			TxLine = TxRTS;
		if (TxLine == TxRTS)
			strcpy(txline,"RTS");
		else
			strcpy(txline,"DTR");
		if (TxLine == TxDTR)    // Georges request for transmitt power control.
			PowerLine = TxRTS;
		else
			PowerLine = TxDTR;
		sprintf(temp,"SetupWindow : COM%d set to 0x%X using %s transmit line control.",
				atoi(port),COMPORT,txline);
		SendingBox.SetWindowText(temp);
		// no break, fall through

	case 2:// Second Parameter
		// Set the Comm Port			
		switch (atoi(port))
		{
		case 0 :  /* Invoke the Scheduler Editor only */
				  SendMessage(WM_SYSCOMMAND,SC_ICON,0);		
				  dlgAbout.DoModal();
				  exit(0);
				  break;
		case 1 :  COMPORT = 0x3F8; break;
		case 2 :  COMPORT = 0x2F8; break;
		case 3 :  COMPORT = 0x3E8; break;
		case 4 :  COMPORT = 0x3E0; break;
		case 5 :  COMPORT = 0x2F0; break;
		case 6 :  COMPORT = 0x2E8; break;
		case 7 :  COMPORT = 0x2E0; break;
		case 8 :  COMPORT = 0x260; break;
		default:  COMPORT = 0x2F8;
		}
		// no break, fall through

	case 1:// First Parameter required
		// Set the Ham Callsign
		strcpy(officialcallsign,callsign);
		MakeCallsign(officialcallsign);	// initialize the callsigns
		break;

	case 0:
	case -1:
		MessageBox(
			"Please Set Command Line Parameters,\n\n"
			"First param\t= Callsign (Enter your ham radio callsign)\n"
			"Second param\t=  Comport (enter integer from 1 to 8)"
			" \n\t1 = 0x3F8\n\t2 = 0x2F8\n\t3 = 0x3E8\n\t4 = 0x3E0\n\t5 = 0x2F0\n\t"
			"6 = 0x2E8\n\t7 = 0x2E0\n\t8 = 0x260\n"
			"Third param\t= Transmit Control (enter RTS or DTR)\n\n"
			"Example:\tRTTYApp  K7TTY  2  RTS\n\n"
			"\tSets callsign to K7TTY, COM2, RTS for xmit control"
			,"Parameters Not Set",MB_OK);
			exit(0);
		break;

	default:
		MessageBox(
			"Too many Command Line parameters has been detected,\n"
			"consult instructions for proper setting of input","Too Many Parameters",MB_OK);
			exit(0);
		break;

	}

    ComPort.SetWindowText(com[atoi(port)]);
	SendingBox.SetWindowText("Initialization");
    Log("***** RTTY Application has been STARTED *****");
	scheduleEnable = FALSE;
	transferSend = TRUE;
	transferCancel = FALSE;
	localLock = FALSE;
	setRepeat = FALSE;
	FlowControlBox.SetWindowText("");
//	FileList.Dir(0,"data/*.*");
	OnRefresh();
	CmRX();
	CmDisable();
	headerEnable = TRUE;
	Header.SetCheck(BF_CHECKED);
	sendNow = FALSE;
//		SetBkColor(dc.GetSafeHdc(),RGB(255,0,0));
//OpenCom(int ComPort,float baud,int parity,int databits,int stopbits);
//		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	OnReload();			// Load the schedule
	OnTimer(0);			// Start the clock ticking every second




 	OnB45();			// Set Buad = 45.45, sets comport
	OnModeMilitary();	// Set Mode to Military
	Slider.SetRange( 0, 500, FALSE );
	Slider.SetPos(425);
	EditDisplay.SetMargins(0,75);

	WM_MSGPORT00 = RegisterWindowMessage("WM_MSGPORT00");
	WM_MSGPORT01 = RegisterWindowMessage("WM_MSGPORT01");

// SoundCard
	vpProcThread = NULL;
	vpProcThread = new CProcThread;
	m_SampsPerSec = 8000;
	m_TimeLimit = 2;
	m_OutputGroup;
	m_SinFreq = 2210;  // half way between 2125/2295;
	m_SourceGroup = 1;
	m_SweepRate = 0;
	m_SweepRange = 12;
	m_BWLimit = TRUE;
	m_EditMark.SetWindowText("2125.0");
	m_EditSpace.SetWindowText("2295.0");
	m_EditPSKFreq.SetWindowText("2210");
	m_EditShift.SetWindowText("170.0");
	m_RadioFreq1.SetCheck(true);

	// IP Port and Address
	m_pConnectSocket = new Telnet;
	m_EditIPAddress.SetWindowText("44.24.103.157");
	m_ComboIP.SetCurSel(0);
	m_ComboSoundCard.SetCurSel(0);
	m_CheckNoSoundCard.SetCheck(1);

	

	m_RTTYAppDlg = this;
 
		
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRTTYAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	if ((nID & 0xFFF0) == IDM_DIALOGEDITOR)
	{
		if (m_pRTTYSchedule == NULL) 
		{
			m_pRTTYSchedule = new RTTYSchedule(this);
			if (m_pRTTYSchedule->Create() == TRUE)
				m_pRTTYSchedule->ShowWindow(SW_SHOW);
		}
		else
			 m_pRTTYSchedule->ShowWindow(SW_SHOW);
	}


	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRTTYAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRTTYAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRTTYAppDlg::OnMode() 
{
	char temp[80];
	sprintf(temp,"Mode Clicked");
	// TODO: Add your control notification handler code here
   SendingBox.SetWindowText(temp);
}



void CRTTYAppDlg::OnSendnext() 
{
	// TODO: Add your control notification handler code here
   if (notSending && scheduleEnable)
	{
		sendNow = TRUE;
		transferCancel = FALSE;
		FlowControlBox.SetWindowText("");
		transferSend = TRUE;
		Log("CmSendNow : Manual Enabling of next in queue.");
	}
	
}

time_t  ParseTime(char * temp) {  // Parse time string to LD
	struct tm t;
	if (strlen(temp) > 0)
	{
		sscanf(temp,"%d/%d/%d %d:%d:%d",
					&t.tm_mon,&t.tm_mday,&t.tm_year,
					&t.tm_hour, &t.tm_min, &t.tm_sec);
		t.tm_mon -= 1;
		t.tm_year = t.tm_year - 1900;
		t.tm_isdst = -1;  // let the system figure it out
		return mktime(&t);
	}
	return 0;
}

void CRTTYAppDlg::Log(char * message)
{
char temp[256];
char xtime[16];
time_t t;
struct tm *gmt;
FILE *out;
unsigned int i;

			t = time(NULL);
			gmt = localtime(&t);
			sprintf(temp,"log/%4d%2d%2d.log",gmt->tm_year+1900,gmt->tm_mon+1,gmt->tm_mday);
				for (i=0;i<strlen(temp);i++)
						if (temp[i] == ' ') temp[i] = '0';
			if ((out = fopen(temp,"a"))
							== NULL)
			{
						SendingBox.SetWindowText("Cannot open LOG file,check for LOG directory.");
						return;
			}
			sprintf(xtime,"%2d:%2d:%2d",gmt->tm_hour,gmt->tm_min,gmt->tm_sec);
			for (i=0;i<strlen(xtime);i++)
						if (xtime[i] == ' ') xtime[i] = '0';
			sprintf(temp,"%s > %s\n",xtime,message);
			fputs(temp,out);
			fclose(out);
}


void CRTTYAppDlg::OnReload() 
{
			char xstring[255] = "";
            char temp[255] = "";
			FILE *in;
			char date[255] = "";
			char times[255] = "";
			char xfile[255] = "";
			int count;
			static time_t tt;
			static time_t tt_input;
			tm *tx;
//			char filename[255];
            unsigned int i;
            unsigned int buflen;
			CFileFind finder;
			int filetime = 1;
			static float localbaud = (float)45.45;
			static float sbaud = (float)0.165;
			
			ListBox.ResetContent();
	   	    transferCancel = FALSE;
		    FlowControlBox.SetWindowText("");
            Log("CmClearItems : Reloading Schedule List");

			if ((in = fopen("data/schedule.lst", "rt"))
							== NULL)
			{
						Log("GetSchedule : Cannot open Schedule.lst input file.");
						return;
			}

   time(&tt);   // Start time of run and for case where count == 1
   tt += 10;    // Make sure first entry is greater than current time
   while (!feof(in))
   {
       strcpy(xstring,"(null)");
	   if( fgets(xstring, 255, in) != NULL)
       {
         count = sscanf(xstring,"%s %s %s",date,times,xfile);
         buflen = strlen(xstring);
         xstring[buflen-1] = '\0';
         for (i=0; i<buflen;i++)
               if (xstring[i] == '\t')
         xstring[i] = ' ';

         // Calculate baud rate
		 if (count == 1)
		 {

           strncpy(temp,xfile,80);

		 }
		 else
			 strncpy(temp,date,80);

		 // Set parameter for calculating file transmitt times
		for (i=0; i<strlen(temp); i++)
                      temp[i] = toupper(temp[i]);

		if (strncmp(temp,"$B45",4) == 0) // Baud Baud 45.45
			localbaud = (float)45.45;
		else if (strncmp(temp,"$B50",4) == 0) // Baud 50.0
			localbaud = (float)50.0;
		else if (strncmp(temp,"$B56",4) == 0) // Baud 56.9
			localbaud = (float)56.9;
		else if (strncmp(temp,"$B74",4) == 0) // Baud 74.4
			localbaud = (float)74.4;
		else if (strncmp(temp,"$B10",4) == 0) // Buad 100.0
			localbaud = (float)100.0;
		else if (strncmp(temp,"$B11",4) == 0) // Baud 110.0
			localbaud = (float)110.0;
		else if (strncmp(temp,"$B30",4) == 0) // Baud 300.0
			localbaud = (float)300.0;


		if (MODE == ascii)
		   sbaud = (float)(10.0 / localbaud);
		else if (MODE == psk31)
		   sbaud = (float)(10.0/40.0);
		else
		   sbaud = (float)(7.5 / localbaud);
   
		 // got a file-only input, Georges special request
		 // time test is only used if first entry in input file
         if (count == 1)
		 {
			 if (tt > time(NULL))
			 {

				tt = tt + (long)(filetime * sbaud);
				
				strcpy(xfile,"data/");
				strcat(xfile,xstring);
				BOOL bWorking = finder.FindFile(xfile);
			    if (bWorking)
				{
			 	   bWorking = finder.FindNextFile();
                   filetime = finder.GetLength();
				}
				else
					filetime = 1;
				tx = localtime(&tt);
				count = 
				sprintf(temp,"%02d/%02d/%4d %02d:%02d:%02d %s",
					tx->tm_mon+1, tx->tm_mday, tx->tm_year+1900,
					tx->tm_hour, tx->tm_min,  tx->tm_sec, date);
				ListBox.AddString(temp);
			}
			else   // default expired time tag case count == 1
			{
				sprintf(temp,
				 "GetSchedule : Expired time tag %s",
                xstring);
			 Log(temp);
			}
		 } // end case count == 1
         // Got a date, remember it for case were count == 1
		 else if (count == 3) 
		 {
			 tt_input = ParseTime(xstring);
			 if (tt_input > 0)
				 tt = tt_input;
			// Got a date, time,file sequence
			if (tt_input > time(NULL))
			{
				tt = tt_input; // new start time for run
		//		sprintf(filename,"data/%s",xfile);
				ListBox.AddString(xstring);
				BOOL bWorking = finder.FindFile(xfile);
			    if (bWorking)
				{
			 	   bWorking = finder.FindNextFile();
                   filetime = finder.GetLength();
				}
			}
			else   // default expired time tag
			{
				sprintf(temp,
					"GetSchedule : Expired time tag %s",
                xstring);
				Log(temp);
			}
		 } // count == 3
		 //else invalid entry, but will skip comment
	   }
	}
   fclose(in);
}

void CRTTYAppDlg::OnDblclkListbox() 
{
char buf[355];
char date[255] = "";
char time[255] = "";
char xfile[255] = "";
//char filename[255];
int count;

		ListBox.GetText(ListBox.GetCurSel(),buf);
		count = sscanf(buf,"%s %s %s",date,time,xfile);
		if (count == 3)
		{
				//	sprintf(filename,"data/%s",xfile);
					if (xfile[0] == '$')  // command, not a file
						return;
					PrintFile(xfile);
		}
	
}


void CRTTYAppDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	time_t currtime;
char temp[80];
static float sbaud = (float)0.165;

switch (nIDEvent)
{
  case 0:  // Set initial once per second timer
           if (!SetTimer(5, 1000U, 0)) {
				sprintf(temp,"OnTimer : Out of Timers - Fatal Abort - Exiting");
				Log(temp);
				exit(0);
			}
			break;
  case 1:  // Set timer for sending
	       if (MODE == ascii)
			   sbaud = (float)(10.0 / BAUD);
		   else
			   sbaud = (float)(7.5 / BAUD);
           if (!SetTimer(10, unsigned int(sbaud*1200), 0)) {
				sprintf(temp,"OnTimer : Out of Timers - Fatal Abort - Exiting");
				Log(temp);
				exit(0);
			}
			break;
  case 2: KillTimer(10);
			 break;
  case 3: KillTimer(5); //kill once per second timer
  case 5: // Once per second handler based on timer ID
			timerTick++;
			time(&currtime);
			strcpy(temp,ctime(&currtime));
			temp[strlen(temp)-1] = '\0';
			ClockBox.SetWindowText(temp);
			if (scheduleEnable)
					Availability(currtime);
			break;
  case 6:   morseTick++;
	        break;
  case 7:  // Set initial once per second timer
           if (!SetTimer(6, 1U, 0)) {
				sprintf(temp,"OnTimer : Out of Timers - Fatal Abort - Exiting");
				Log(temp);
				exit(0);
			}
			break;
  case 8: KillTimer(6);
			 break;
  case 10: 	if (MODE != ascii)
			    xmitchar(LTRS);
            break;  // callback for baud timer
	} // end switch
	
//	CDialog::OnTimer(nIDEvent);
}

void CRTTYAppDlg::OnB45() 
{
    CheckRadioButton( IDC_45, IDC_300, IDC_45 );
	if (MODE == psk31)
	{
		psk_freq = 1500;
		DisplayPSK31Frequency();
	}
	else
	{
		BAUD = (float)45.45;
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}

}

void CRTTYAppDlg::OnB50() 
{
	CheckRadioButton( IDC_45, IDC_300, IDC_50 );
	if (MODE == psk31)
	{
		psk_freq = 1600;
		DisplayPSK31Frequency();
	}
	else
	{
		BAUD = 50.0;
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnB56() 
{
	CheckRadioButton( IDC_45, IDC_300, IDC_56 );
	if (MODE == psk31)
		{
		psk_freq = 1700;
		DisplayPSK31Frequency();
	}
	else
	{
		BAUD = (float)56.9;
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnB74() 
{
	CheckRadioButton( IDC_45, IDC_110, IDC_74 );
	if (MODE == psk31)
		{
		psk_freq = 1800;
		DisplayPSK31Frequency();
	}
	else
	{
		BAUD = (float)74.2;
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnB100() 
{
	CheckRadioButton( IDC_45, IDC_110, IDC_100 );
	if (MODE == psk31)
		{
		psk_freq = 1900;
		DisplayPSK31Frequency();
	}
	else
	{
		BAUD = 110.0;
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnB110() 
{
   CheckRadioButton( IDC_45, IDC_300, IDC_110 );
   if (MODE == psk31)
		{
		psk_freq = 2000;
		DisplayPSK31Frequency();
	}
	else
	{
	  BAUD = 110.0;
	  OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnB300() 
{
	CheckRadioButton( IDC_45, IDC_300, IDC_300 );
	if (MODE == psk31)
		{
		psk_freq = 2100;
		DisplayPSK31Frequency();
	}
	else
	{
	   BAUD = 300.0;
	   OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	}
}

void CRTTYAppDlg::OnModeMilitary() 
{
	CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_MILITARY );
	DATABITS = d5;
	MODE = military;
	OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	fnStopSoundCard();
	DisplayRS232Mode();
}

void CRTTYAppDlg::OnModeIta2() 
{
	CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_ITA2 );
	DATABITS = d5;
	MODE = ita2;
	OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	fnStopSoundCard();
	DisplayRS232Mode();
}

void CRTTYAppDlg::OnModeTelex() 
{
	CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_TELEX );
	DATABITS = d5;
	MODE = telex;
	OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	fnStopSoundCard();
	DisplayRS232Mode();
}

void CRTTYAppDlg::OnModeAscii() 
{
	CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_ASCII );
	DATABITS = d8;
	MODE = ascii;
	OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
	fnStopSoundCard();
	DisplayRS232Mode();
}

void CRTTYAppDlg::OnModePSK31() 
{
	int status;
	extern float psk_freq;
	int soundcardid;


	MODE = psk31;
	CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_RADIOPSK31 );
	soundcardid = GetSoundCardID();
	if (soundcardid > 10)
	{
		AfxMessageBox("Please Select a Sound Card");
		CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_MILITARY );
		return;
	}
	fnStopSoundCard();
	status = fnStartSoundCard(m_hWnd,soundcardid,0);
	ReportSoundCardError(status); // may not return if error is FATAL
	if (status) // i.e. bad sound card open
		CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_MILITARY );
//	fnStartSoundCard(NULL,1,3);
//	fnEnableRXChannel(0,true);
	DisplayPSK31Frequency();
}


void CRTTYAppDlg::OnModeMorse() 
{
    CheckRadioButton( IDC_MILITARY, IDC_MORSE, IDC_MORSE );  
	MODE = morse;
	fnStopSoundCard();
}


void CRTTYAppDlg::OnRyryry() 
{
	if (notSending)
	{
		if (MODE == morse)
			return;
		Log("CmRYRYRYRY : Sending <RYRYRYRY.txt> file.");
		localLock = TRUE;
		CmDisable();
		CmTX();
		wdelay(3);
		notSending = FALSE;
		do
			TXFile("RYRYRYRY.txt",MODE);
		while (setRepeat && !transferCancel);
		wdelay(3);
		CmRX();
		localLock = FALSE;
	}
}
	

void  CRTTYAppDlg::TXFile(char * fname,int MODE)
{
char xstring[80] = "";
char ystring[80] = "";
char * buf;
FILE *in;
int i;
int buflen;
int count = 0;
char filename[255] = "data/";
char editsavebox[255];

	transferSend = TRUE;
	transferCancel = FALSE;
	FlowControlBox.SetWindowText("");
	if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
	{
		EditDisplay.SetWindowText("Not enough memory to allocate buffer\n");
		Log("TXFile : Not enough memory to allocate buffer.");
		return;  /* terminate program if out of memory */
	}
	PrintFile(fname);
	CanEdit.SetCheck(BF_GRAYED);
	strcat(filename,fname);
	if ((in = fopen(filename, "rb")) == NULL)
	{
	sprintf(xstring, "[TXFile : Cannot open %s input file.]",filename);
	EditDisplay.SetWindowText(xstring);
	Log(xstring);
	return;
	}	
	fread(buf, MAXSIZE-2, 1, in);  // allow for nulls at end.
	SendingBox.SetWindowText("");
	sprintf(xstring, "TXFile : Sending file <%s>.",fname);
	QueueBox.SetWindowText(xstring);
    Log(xstring);
	buflen = strlen(buf);
//    OnTimer(1);  // set timer #10 for callback;
			
	for (i=0;i<buflen;i++)
	{
		count++;
		sprintf(xstring,"C=%d",buflen - count);
		SendQueueBox.SetWindowText(xstring);
		EditSaveBox.GetWindowText(editsavebox,sizeof(editsavebox));
		if (strcmp(fname,editsavebox) == 0)  // the roving cursor follows text
			EditDisplay.SetSel(i,i+1,0);
		while (!transferSend)
		{
			GiveUp();                    // pause in effect
			if (MODE == psk31)
			{
				fnSendTXCharacter(0,false);
				while(fnGetTXCharsRemaining() > 2)
					GiveUp();
			}
			if (transferCancel) break;   // break out of while
		}
		if (transferCancel) break;      // break out of for loop
		if (MODE == morse)
			SendMorse(buf[i]);
		else if ((MODE == ascii) || (MODE == psk31))
		{
            buf[i] = (int) baudot_macro(buf[i],MODE);
			xmitchar(buf[i] & 0x7F);  // raw ascii transmit, mask bit8
			switch (buf[i])
			{
			case '\r':	break;  // eat the return
			case '\n':	xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,'\r',0);
						break;
			default :	xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,buf[i],0);
				}
		}
         else
		{
			buf[i] = toupper(buf[i]);
			send_baudot((int) buf[i],MODE);  // default baudot
			
		}
	    SendingBox.GetWindowText(ystring,sizeof(ystring));
		sprintf(xstring,"%c",buf[i]);
		switch (buf[i])
		{
			case '\r':  
			case '\n':
			case '\0':  SendingBox.SetWindowText("");
					    ystring[0] = '\0'; // clear ystring.break;
				        break;
			default  :  if (strlen(ystring) >78)
									    ystring[0] = '\0';
						strcat(ystring,xstring);
						SendingBox.SetWindowText( ystring);
		}
		GiveUp();
	}

	SendingBox.SetWindowText("");   // One liner of xmitted text
	QueueBox.SetWindowText("");     // Files in the send queue
	SendQueueBox.SetWindowText(""); // Countdown of bytes to send
//	OnTimer(2); // kill timer #10
	fclose(in);
	free(buf);
}


void CRTTYAppDlg::Availability(time_t currtime)
{
char temp[255];
char buf[255];
char date[120] = "";
char times[255] = "";
char xfile[255] = "";
char filename[255];
int count = 0;
FILE *in;

time_t tt;

		if ((CWTimer > -1) && (transmitOn == TRUE))		// CWID timer enabled
		{
			CWTimer++;
			sprintf(temp,"%d",CWTIMER - CWTimer);
			CWTimerDisplay.SetWindowText(temp);
		}
		if ((CWTimer > CWTIMER) && (transmitOn == TRUE) && !localLock)	// Time to do CW ID
		{
				Cwid(CWidString);
				CWTimer = 0;
		}

		if (ListBox.GetText(0,buf)>0)
		{
			tt = ParseTime(buf);
			tt = tt - currtime;
			tt_queue = tt;  // global time not on this stack
			count = sscanf(buf,"%s %s %s",date,times,xfile);
		//	sprintf(temp,"Next action is <%s>.",xfile);
		//	QueueBox.SetWindowText(temp);
			if ((!localLock && (count == 3) && ((tt <= 0)) || sendNow))
			{
        		ListBox.DeleteString(0);
				if (xfile[0] == '$')  // First action to handle commands
				{
				 SetMode(&xfile[1]);
				 sendNow = FALSE;
				 return;
				}

				localLock = TRUE;
				notSending = FALSE;
				sendNow = FALSE;
				sprintf(temp,"File <%s> in TRANSMIT Queue.",xfile);
				QueueBox.SetWindowText(temp);
				Log(temp);
				SendingBox.SetWindowText("");
				if (!transferCancel)
				{
					sprintf(filename,"data/%s",xfile);
//					if (PrintFile(xfile) == GOOD)
					if ((in = fopen(filename, "rb"))!= NULL) // check for bad filename
					{
						fclose(in);
						if (MODE == morse)
						{
							CmTX();
							OnTimer(7);
							morsedelay(50);
						}
						else
						{
							CmTX();
						    wdelay(5);
						}
						if (!transferCancel && headerEnable)
							TXFile("header.txt",MODE);
						if (!transferCancel) 
							TXFile(xfile,MODE);
						if (!transferCancel && headerEnable)
							TXFile("footer.txt",MODE);						
						if (MODE == morse)
							OnTimer(8);
						else if (!transferCancel) 
							wdelay(5);
             }
             else
             {
                sprintf(temp,
                   "SendAbort : File <%s> could not be opened.",xfile);
                Log(temp);
				SendingBox.SetWindowText(temp);
             }
			}
			if (tt_queue > 0)  // keeps TX from cycling between jobs
				CmRX();
			if (!transferCancel)
			{
				sprintf(temp,"Completed sending <%s>.",xfile);
			}
			else
			{
				sprintf(temp,"ABORTED sending <%s>.",xfile);
				CmDisable();
				QueueBox.SetWindowText("");
			}
				QueueBox.SetWindowText(temp);
				Log(temp);
				notSending = TRUE;
				localLock = FALSE;
			} // local lock
			else
			{
				sprintf(temp,"%ld",tt);
				CountDownBox.SetWindowText(temp);
			}
		}
		else // list box empty
		{
			CmDisable();
			QueueBox.SetWindowText("Queue Empty: Nothing to Send.");
			Log("Queue Empty: Nothing to Send.");
			tt_queue = 10; // number greater than zero to force RX			
		}
}


void CRTTYAppDlg::SetMode(char * mode)
{
unsigned int i;
char temp[255];
int port;
char tempc[30];
float tempf ;

	for (i=0; i<strlen(mode); i++)
	 mode[i] = toupper(mode[i]);

	if (strncmp(mode,"ASC",3) == 0)      // Mode ASCII
	 OnModeAscii();
	else if (strncmp(mode,"ITA",3) == 0) // Mode ITA2
	OnModeIta2();
	else if (strncmp(mode,"TEL",3) == 0) // Mode TELEX
	OnModeTelex();
	else if (strncmp(mode,"MIL",3) == 0) // Mode Military
	OnModeMilitary();
	else if (strncmp(mode,"F15",3) == 0) // PSK31
		psk_freq = 1500.0;
	else if (strncmp(mode,"F16",3) == 0) // PSK31
		psk_freq = 1600.0;
	else if (strncmp(mode,"F17",3) == 0) // PSK31
		psk_freq = 1700.0;
	else if (strncmp(mode,"F18",3) == 0) // PSK31
		psk_freq = 1600.0;
	else if (strncmp(mode,"F19",3) == 0) // PSK31
		psk_freq = 1900.0;
	else if (strncmp(mode,"F20",3) == 0) // PSK31
		psk_freq = 2000.0;
	else if (strncmp(mode,"F21",3) == 0) // PSK31
		psk_freq = 2100.0;
	else if (strncmp(mode,"PSK",3) == 0) // Mode PSK31
	{
		OnModePSK31();
		if (strncmp(mode,"PSK=",4) == 0) // custom frequency
		{
			tempf = (float)atof(&mode[4]);
			if (tempf > 200)
			{
				psk_freq = tempf;
				sprintf(tempc,"%10.3f",tempf);
				m_EditPSKFreq.SetWindowText(tempc);
			}
		}
	}
	else if (strncmp(mode,"FSK=",4) == 0) // custom frequency
	{
		tempf = (float)atof(&mode[4]);
		if (tempf > 200)
		{
			fsk_freq = tempf;
			sprintf(tempc,"%10.3f",tempf);
			m_EditPSKFreq.SetWindowText(tempc);
		}
	}
	else if (strncmp(mode,"CWID" ,4) == 0) // CWID
		Cwid(CWidString);
	else if (strncmp(mode,"CWT",3) == 0) // Start 1 hour CWID
	{
	  CWTimerCheck.SetCheck(BF_CHECKED);
	  OnCWTimer();
	}
	else if (strncmp(mode,"CWS",3) == 0) // Stop CW ID timer
	{	 
	  CWTimerCheck.SetCheck(BF_UNCHECKED);
	  OnCWTimer();
	}
	else if (strncmp(mode,"CW" ,2) == 0) // Mode CW
	OnModeMorse();
	else if (strncmp(mode,"TX" ,2) == 0) // Transmit
	 CmTX();
	else if (strncmp(mode,"RX" ,2) == 0) // Receive
	 CmRX();
	else if (strncmp(mode,"PON",3) == 0) // Power ON switch
	  CmPowerON();
	else if (strncmp(mode,"POF",3) == 0) // Power OFF switch
	  CmPowerOFF();
	else if (strncmp(mode,"DIS",3) == 0) // Disable
	{
	 CmDisable();
	 CmRX();    // Unique Script need to turn off transmitter
	}
	else if (strncmp(mode,"B45",3) == 0) // Baud Baud 45.45
	 OnB45();
	else if (strncmp(mode,"B50",3) == 0) // Baud 50.0
	 OnB50();
	else if (strncmp(mode,"B56",3) == 0) // Baud 56.9
	 OnB56();
	else if (strncmp(mode,"B74",3) == 0) // Baud 74.4
	 OnB74();
	else if (strncmp(mode,"B10",3) == 0) // Buad 100.0
	  OnB100();
	else if (strncmp(mode,"B11",3) == 0) // Baud 110.0
	  OnB110();
	else if (strncmp(mode,"B30",3) == 0) // Baud 300.0
	  OnB300();
	else if (strncmp(mode,"RTS",3) == 0)  // RTS for transmit
	  TxLine = TxRTS;
	else if (strncmp(mode,"DTR",3) == 0)  // DTR for transmit
	  TxLine = TxDTR;
	else if (strncmp(mode,"REL",3) == 0)  // Reload Script
	  OnReload();
	else if (strncmp(mode,"HEA",3) == 0)  // Header
	{   
	  Header.SetCheck(BF_CHECKED);
	  OnHeader();
	}
	else if (strncmp(mode,"NOH",3) == 0)  // No Header
	{
	  Header.SetCheck(BF_UNCHECKED);
	  OnHeader();
	}
	else if (strncmp(mode,"DID",3) == 0)  // Header
	{   
	  Diddle.SetCheck(BF_CHECKED);
	  OnDiddle();
	}
	else if (strncmp(mode,"NOD",3) == 0)  // No Header
	{
	  Diddle.SetCheck(BF_UNCHECKED);
	  OnDiddle();
	}
	else if (strncmp(mode,"COM",3) == 0) // Set a new com port
	{
	  port = atoi(&mode[3]);
	  switch (port)
	  {
		case 1 :  COMPORT = 0x3F8; break;
		case 2 :  COMPORT = 0x2F8; break;
		case 3 :  COMPORT = 0x3E8; break;
		case 4 :  COMPORT = 0x3E0; break;
		case 5 :  COMPORT = 0x2F0; break;
		case 6 :  COMPORT = 0x2E8; break;
		case 7 :  COMPORT = 0x2E0; break;
		case 8 :  COMPORT = 0x260; break;
		default:  SendingBox.SetWindowText("Error: Invalid Port ID");
				  return;
	  }
		CmRX();
		ComPort.SetWindowText(com[port]);
		OpenCom(COMPORT,BAUD,pNone,DATABITS,s2);
		sprintf(temp,"ComPort Changed to %s",com[port]);
		Log(temp);
		sprintf(temp,"SetupWindow : COM%d set to 0x%X.",
				port,COMPORT);
		SendingBox.SetWindowText(temp);
	}
}

void CRTTYAppDlg::CmPowerON()  // Apply power to the transmitter
{
	int MCRSave;

	if (transmitOn == TRUE)		// Safe the transmitter
		CmRX();  
	MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable
	_outp(MCR+COMPORT, MCRSave | PowerLine);   /* Raise PowerLine*/
	Log("CmRX : Power Turned OFF");
	PowerON.SetCheck(BF_CHECKED);

}

void CRTTYAppDlg::CmPowerOFF()  // Remove power to the transmitter
{
	int MCRSave;
	
	if (transmitOn == TRUE)		// Safe the transmitter & Cancel any session
		CmCancel();
	MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable
	_outp(MCR+COMPORT,MCRSave & (~PowerLine&0xFF));  /* Drop PowerLine */
	Log("CmPowerOFF : Power turned OFF");
	PowerON.SetCheck(BF_UNCHECKED);

}

void cStartSocketThread(void*dummy)
{
	m_pConnectSocket->StartSocketConnect(
		m_pConnectSocket->m_lpszHostAddress,
		m_pConnectSocket->m_nHostPort);
	_endthread();
}

#define BUTTON_UNCHECKED 0
#define BUTTON_CHECKED 1

void CRTTYAppDlg::CmTX()
{
	int MCRSave;
	double mark, space, shift,freq;
	char temps[30];
	extern double Freq_Shift;
	bool status;
	int errorvalue;
	char str[256];

	if (transmitOn)
		return;

	// disable nosound button
	m_CheckNoSoundCard.EnableWindow(false);
	m_ComboSoundCard.EnableWindow(false);

	// Telnet session
//	LPCTSTR lpszHostAddress;
	UINT nHostPort;
	char ipaddress[30];
	char ipport[30];
	m_ComboIP.GetWindowText(ipport,sizeof(ipport));
	m_EditIPAddress.GetWindowText(ipaddress,sizeof(ipaddress));
	nHostPort = atoi(ipport);

	if (nHostPort > 0)
	{
		nHostPort += 6000-1;
		status = m_pConnectSocket->StartSocketConnect(LPCTSTR(ipaddress), nHostPort);
		if (status)
		{
			errorvalue = GetLastError();
			sprintf(str,"Failed to connect to %s on port %i\n"
				        "Please correct IP address and try again.\n"
						"Socket error reported as %i",ipaddress,nHostPort,errorvalue);
			MessageBox(str,"TCP/IP Connect Failure",MB_ICONERROR); 
			return; // failed to connect, a requirement
		}
	}

	// Continue rest of initialization
	transmitOn = TRUE;	
	TransmitBox.SetWindowText("  ON  ");
	Log("CmTX : Transmitter ON");
	MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable
	_outp(MCR+COMPORT, MCRSave | TxLine);   /*  transmit */

	// Decide to use PSK31 DLL module or BAUDOT Module
	if ((MODE != psk31) && (MODE != morse))
	{	
		if (m_CheckNoSoundCard.GetCheck() == BUTTON_UNCHECKED)
		{
			if (m_RadioFreq1.GetCheck())
				{
				m_EditPSKFreq.GetWindowText(temps,30);
				freq= atof(temps);
				m_EditShift.GetWindowText(temps,30);
				shift = atof(temps)/2.0;
				sprintf(temps,"%8.2f",freq - shift);
				m_EditMark.SetWindowText(temps);
				sprintf(temps,"%8.2f",freq + shift);
				m_EditSpace.SetWindowText(temps);
				m_SinFreq = (unsigned int)freq;
				Freq_Shift = shift;
			}
			else
			{
				m_EditSpace.GetWindowText(temps,30);
				space = atof(temps);
				m_EditMark.GetWindowText(temps,30);
				mark = atof(temps);
				shift = fabs(mark-space);
				freq = __max(mark,space)-shift;
				sprintf(temps,"%8.2f",freq);
				m_EditPSKFreq.SetWindowText(temps);
				sprintf(temps,"%6.1f",shift);
				m_EditShift.SetWindowText(temps);
				Freq_Shift = shift/2.0;
				m_SinFreq = (unsigned int)freq;
			}
			vpProcThread = NULL;
			vpProcThread = new CProcThread;
			m_SampsPerSec = 8000;
			m_TimeLimit = 2;
			m_OutputGroup;
			m_SourceGroup = 1;
			m_SweepRate = 0;
			m_SweepRange = 12;
			m_BWLimit = TRUE;

			//Start Thread for NON-DLL Sound Cardsupport
			extern CRITICAL_SECTION vCriticalSection;
			vpProcThread->StartThread( this );
			InitializeCriticalSection(&vCriticalSection);

			m_EditPSKFreq.SetReadOnly(true);
			m_EditShift.SetReadOnly(true);
		}
	}
	else if (MODE == psk31)
	{
		char temps[30];
		m_EditPSKFreq.GetWindowText(temps,30);
		psk_freq = (float)atof(temps);
		fnSetTXFrequency((long)psk_freq);
		fnStartTX(0);
		m_EditPSKFreq.SetReadOnly(true);
		m_EditShift.SetReadOnly(true);
	}
	else if (MODE == ascii)
		return;
	else if (MODE == morse)
		return;
	else // all baudot modes
	{
		while (diddleEnable && !localLock && transmitOn) 
		{
			xmitchar(LTRS);
		//	GiveUp();

		} 
	}
}


void CRTTYAppDlg::CmRX()
{
	int MCRSave;

	if (!transmitOn)
		return;

	// Enable nosound button
	m_CheckNoSoundCard.EnableWindow(true);
	m_ComboSoundCard.EnableWindow(true);

	// Telnet session
	if (m_pConnectSocket->FromHandle(m_pConnectSocket->m_hSocket) != NULL)
	{
		m_pConnectSocket->Close();
		m_pConnectSocket->m_NetStatus = NET_OFF;
		m_EditIPAddress.SetReadOnly(false);
		m_EditAuthentication.SetReadOnly(false);
		m_ComboIP.EnableWindow(true);
		
	}

	transmitOn = FALSE;
	CWTimerCheck.SetCheck(BF_UNCHECKED);  // Disable CW Timer
	OnCWTimer();
	TransmitBox.SetWindowText("  OFF  ");
	notSending = TRUE;
	MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable
	_outp(MCR+COMPORT,MCRSave & (~TxLine&0xFF));  /* receive */
	Log("CmRX : Transmitter OFF");
	if (m_RadioFreq1.GetCheck())
	{
		m_EditPSKFreq.SetReadOnly(false);
		m_EditShift.SetReadOnly(false);
	}
	else
	{
		m_EditMark.SetReadOnly(false);
		m_EditSpace.SetReadOnly(false);
	}
	if (MODE == psk31)
	{
		fnClearTXBuffer();
		fnStopTX();
		WaitSeconds(2);
		fnClearTXBuffer();
		fnStopTX();
	}
	else if (MODE != morse)
	{
		CalcMSK_TX_char[0] = 0;
		WaitSeconds(2);
		m_fProcThreadQuit = true;
	}


	


}

void CRTTYAppDlg::CmEnable()
{
	AutoSendBox.SetWindowText("ENABLE");
	FlowControlBox.SetWindowText("");
	scheduleEnable = TRUE;
	transferCancel = FALSE;
	Log("CmEnable : Scheduler ENABLED");
}

void CRTTYAppDlg::CmDisable()
{
	AutoSendBox.SetWindowText("DISABLED");
	CountDownBox.SetWindowText("");
//	QueueBox.SetWindowText("");
	scheduleEnable = FALSE;
	sendNow = FALSE;
	Log("CmDisable : Scheduler DISABLED");
}

void CRTTYAppDlg::CmPause()
{
	if (localLock)
	{
		FlowControlBox.SetWindowText("PAUSE");
		transferSend = FALSE;
		Log("CmPause : Session PAUSED");
	}
}

void CRTTYAppDlg::CmResume()
{
	if (localLock)
	{
		FlowControlBox.SetWindowText("RESUME");
		transferSend = TRUE;
		Log("CmResume : Session RESUMED");
	}
}

void CRTTYAppDlg::CmCancel()
{
	if (localLock)               // disable the Scheduler
	{
		if (MODE == psk31)
			fnAbortTX();
		else
			CmRX();
		CmDisable();
		FlowControlBox.SetWindowText("CANCEL");
		transferCancel = TRUE;
		sendNow = FALSE;
		Log("CmCancel : Session CANCELED");
		OnCanEdit();
	}
}

int CRTTYAppDlg::PrintFile(char * fname)
{
char xstring[255] = "";
char * buf;
FILE *in;
unsigned int i;
unsigned int len;
char filename[255] = "data/";
   
		if(strstr(fname,"log/"))
			strcpy(filename,fname);
		else
			strcat(filename,fname);
		if (fname[0] == '$')   // Got a Command, so do nothing
		{
			return GOOD;
		}
		else
			EditSaveBox.SetWindowText(fname);
		CanEdit.SetCheck(BF_UNCHECKED);
		OnCanEdit();
		if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
		{
			EditDisplay.SetWindowText(
				"PrintFile : Not enough memory to allocate buffer\n");
			Log("PrintFile : Not enough memory to allocate buffer.");
			return BAD;  /* terminate program if out of memory */
		}
		if ((in = fopen(filename, "rb"))== NULL)
		{
			sprintf(xstring,"[PrintFile :Cannot open %s input file.]",filename);
			EditDisplay.SetWindowText(xstring);
			Log(xstring);
			return BAD;
		}
		fread(buf, MAXSIZE-2, 1, in);  // must allow for null termination
		if (MODE != ascii)
		{
			len = strlen(buf);
			for (i=0;i<len;i++)
				buf[i] = toupper(buf[i]);
		}
		EditDisplay.SetWindowText(buf);
		fclose(in);
		free(buf);
   return GOOD;
}


void CRTTYAppDlg::wdelay(int seconds)
{
 // Delay Timer (seconds)
	timerTick = 0;
	while ( timerTick < seconds)
	{
		if (MODE != ascii)
			xmitchar(LTRS);
		GiveUp();
	}
}





void CRTTYAppDlg::OnCanEdit() 
{

    if (!notSending)
	{
//		CanEdit.SetCheck(BF_UNCHECKED);
		CanEdit.SetCheck(BF_GRAYED);
		EditDisplay.SetReadOnly(TRUE);
		EditSaveBox.SetReadOnly(TRUE);
	}
	else if (CanEdit.GetCheck() == BF_CHECKED)
	{
		EditDisplay.SetReadOnly(FALSE);
		EditSaveBox.SetReadOnly(FALSE);
		EditDisplay.SetMargins( 0, 75);
		Slider.SetPos(425);
//		EditDisplay.FmtLines(TRUE);
	}
	else if (CanEdit.GetCheck() == BF_UNCHECKED)
	{
		EditDisplay.SetReadOnly(TRUE);
		EditSaveBox.SetReadOnly(TRUE);
		EditDisplay.SetMargins( 0, 75);
		Slider.SetPos(425);
//		EditDisplay.FmtLines(FALSE);
	}
	else
	{
		CanEdit.SetCheck(BF_UNCHECKED);
		EditDisplay.SetReadOnly(TRUE);
		EditSaveBox.SetReadOnly(TRUE);
		EditDisplay.SetMargins( 0, 75);
		Slider.SetPos(425);
		EditDisplay.FmtLines(FALSE);
	}
}



void CRTTYAppDlg::OnRepeat() 
{
	if (Repeat.GetCheck() == BF_CHECKED)
		setRepeat = TRUE;
	else if (Repeat.GetCheck() == BF_UNCHECKED)
		setRepeat = FALSE;	
}


void CRTTYAppDlg::OnThefox() 
{
	if (notSending)
				{
					if (MODE == morse)
						return;
		            Log("CmRYRYRYRY : Sending <RYRYRYRY.txt> file.");
					localLock = TRUE;
					CmDisable();
					CmTX();
					wdelay(3);
					notSending = FALSE;
					do
						TXFile("thefox.txt",MODE);
					while (setRepeat && !transferCancel);
					wdelay(3);
					CmRX();
					localLock = FALSE;
				}
	
}

void CRTTYAppDlg::OnEventlog() 
{
char temp[255];
time_t t;
struct tm *gmt;
unsigned int i;

			t = time(NULL);
			gmt = localtime(&t);
			sprintf(temp,"log/%4d%2d%2d.log",
						gmt->tm_year+1900,gmt->tm_mon+1,gmt->tm_mday);
				for (i=0;i<strlen(temp);i++)
						if (temp[i] == ' ') temp[i] = '0';
			PrintFile(temp);
			i = EditDisplay.GetLineCount() - 12;
			if (i > 0)
						EditDisplay.LineScroll(i,0);
	
}

void CRTTYAppDlg::OnDeleteItem() 
{
	ListBox.DeleteString(ListBox.GetCurSel());	
}

void CRTTYAppDlg::OnAddItem() 
{

	if (m_pRTTYSchedule == NULL) 
		{
			m_pRTTYSchedule = new RTTYSchedule(this);
			if (m_pRTTYSchedule->Create() == TRUE)
				m_pRTTYSchedule->ShowWindow(SW_SHOW);
		}
		else
			 m_pRTTYSchedule->ShowWindow(SW_SHOW);
		/*
char temp[256] = "";
RTTYSchedule dlgAbout;
		
		if (MODE != morse)
			OnTimer(1);
		int nResponse = dlgAbout.DoModal();
		if (nResponse == IDOK)
	{
//			if (3 == sscanf(listboxtext,"%s %s %s",temp,temp,temp))
//				AddListboxItem(listboxtext);
			OnTimer(2);
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
			OnReload();
	}
	else if (nResponse == IDCANCEL)
	{
		OnTimer(2);
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
*/	
}

void CRTTYAppDlg::OnCompose() 
{
	if (notSending)
	{
      PrintFile("compose.txt");
      CanEdit.SetCheck(BF_CHECKED);
	  OnCanEdit();
	}
	
}

void CRTTYAppDlg::OnSend() 
{
FILE *out;
char * buf;

	if (notSending)
	{
		localLock = TRUE;
		CmDisable();
		if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
		{
			EditDisplay.SetWindowText(
				"PrintFile : Not enough memory to allocate CmSendCompose buffer\n");
		Log("PrintFile : Not enough memory to allocate CmSendCompose buffer.");
		return;  /* terminate program if out of memory */
		}
		EditDisplay.GetWindowText(buf,MAXSIZE);
		if ((out = fopen("data/EditDisplayTemp.txt","wb")) == NULL)
		{
			Log("Cannot write EditDisplayTemp.txt file.");
			return;
		}
		fputs(buf,out);
		fclose(out);
		free(buf);
		EditDisplay.SetReadOnly(TRUE);
		CanEdit.SetCheck(BF_GRAYED);
		OnCanEdit();
		Log("CmSendCompose : Sending <EditDisplayTemp.txt> file.");
		CmTX();
		wdelay(3);
		notSending = FALSE;
		do
			TXFile("EditDisplayTemp.txt",MODE);
		while (setRepeat && !transferCancel);
		wdelay(3);
		CmRX();
		CanEdit.SetCheck(BF_UNCHECKED);
		localLock = FALSE;
	}
	
}

void CRTTYAppDlg::OnSave() 
{
FILE *out;
char * buf;
char fname[255];
char filename[255] = "data/";
if (CanEdit.GetCheck())
{
	if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
	{
		EditDisplay.SetWindowText(
			"PrintFile : Not enough memory to allocate CmCompose buffer\n");
		Log("PrintFile : Not enough memory to allocate CmCompose buffer.");
		return;  /* terminate program if out of memory */
	}
//	EditDisplay.SetMargins(0,75);
	EditDisplay.FmtLines(TRUE);
	EditDisplay.GetWindowText(buf,MAXSIZE);
	EditSaveBox.GetWindowText(fname,254);
	strcat(filename,fname);
	if ((out = fopen(filename,"wb")) == NULL)
	{
		sprintf(filename,"CmEditSave : Cannot open <%s> file",fname);
		Log(filename);
		return;
	}
	fputs(buf,out);
	fclose(out);
	free(buf);
	}	
}

void CRTTYAppDlg::OnHeader() 
{
if (Header.GetCheck() == BF_CHECKED)
    headerEnable = TRUE;
 else if (Header.GetCheck() == BF_UNCHECKED)
	headerEnable = FALSE;
	
}

BOOL CRTTYAppDlg::DestroyWindow() 
{
	CmRX();   // Last chance on destruction to turn off transmitter
	OnTimer(3);  // kill once per second timer, Windows 3.1 issue.
	Log("***** RTTY Application has been TERMINATED *****");
	return CDialog::DestroyWindow();
}

void CRTTYAppDlg::AddListboxItem(char * buf)
{
	int i;
	i = ListBox.GetCurSel();
	if (i == -1) i = 0;
	ListBox.InsertString(i,buf);
}

void CAboutDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	char temp[80];
	const char Ascii[]    = "ASCII";
	const char Ita2[]     = "ITA#2";
	const char Telex[]    = "TELEX";
	const char Military[] = "Military";
	const char *Mode[4] = {Ascii,Ita2,Telex,Military};



	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here


	AboutListBox.AddString(" This application was written for the");

	sprintf(temp,"%s RTTY broadcast transmitter.",WideCallsign);
	AboutListBox.AddString(temp);
	AboutListBox.AddString(longdash);

	sprintf(temp,"Comport is set to 0x%X",COMPORT);
	AboutListBox.AddString(temp);
	sprintf(temp,"Baud Rate is set to %f.",BAUD);
	AboutListBox.AddString(temp);

	if (DATABITS == d8)
		sprintf(temp,"Data Bits is set to 8 BITS.");
	else
		sprintf(temp,"Data Bits is set to 5 Bits.");
	AboutListBox.AddString(temp);
	sprintf(temp,"Mode is set to %s.",Mode[MODE]);
	AboutListBox.AddString(temp);
	if (TxLine == TxRTS)
		AboutListBox.AddString("Using RTS line for transmit control");
	else if (TxLine == TxDTR)
		AboutListBox.AddString("Using DTR line for transmit control.");
	else
		AboutListBox.AddString("Error: Line control for TX not set.");
	AboutListBox.AddString(longdash);
	AboutListBox.AddString("Command Line Parameters:");
	AboutListBox.AddString("   RTTYApp [port #   ] [Xmit line]");
	AboutListBox.AddString("   RTTYApp [012345678] [RTS,DTR  ]");
	AboutListBox.AddString(longdash);
	AboutListBox.AddString("Available Ports");
	AboutListBox.AddString("   COM0 = 0 Launches Editor ONLY");
	AboutListBox.AddString("   COM1 = 0x3F8");
	AboutListBox.AddString("   COM2 = 0x2F8");
	AboutListBox.AddString("   COM3 = 0x3E8");
	AboutListBox.AddString("   COM4 = 0x3E0");
	AboutListBox.AddString("   COM5 = 0x2F0");
	AboutListBox.AddString("   COM6 = 0x2E8");
	AboutListBox.AddString("   COM7 = 0x2E0");
	AboutListBox.AddString("   COM8 = 0x260");
	AboutListBox.AddString(" ");
	AboutListBox.AddString("--------- Scripted Commands  --------------");
	for (int i=0;i < sizeofcommands + deltacommands;i++)
		AboutListBox.AddString(commands[i]);
		AboutListBox.AddString(" ");
	AboutListBox.AddString("--- Macro Commands Expand in Text Files ----");
	AboutListBox.AddString("^L   // Full date 'TUESDAY, MAY 12, 2001'");
	AboutListBox.AddString("^D   // Day,month,day,year 'MAY 12, 2001'");
	AboutListBox.AddString("^W'  // Weekday            'TUESDAY'");
	AboutListBox.AddString("^T   // Local Time         '12:35(PST)'");
	AboutListBox.AddString("^U   // UTC Time           '12:35(UTC)'");
	AboutListBox.AddString("^1   // Sends BELL once");
	AboutListBox.AddString("^2   // Sends Bell twice");
	AboutListBox.AddString("...  // Sends Bell 1 - 9 Times");
	AboutListBox.AddString("^9   // Sends Bell nine times, annoying!");
	AboutListBox.AddString(longdash);

}

void CRTTYAppDlg::morsedelay(int xtime)
{
 // Delay Timer (seconds)
	morseTick = 0;
	while ( morseTick < xtime)
	{
		GiveUp();
	}
}


void CRTTYAppDlg::OnFileadd() 
{
char xstring[255];
int i;
char buf[255];
char date[255] = "";
char times[255] = "";
char xfile[255] = "";
char temp[255];
int count;
int filetime = 1;
time_t tt;
tm *tx;

	if (FileList.GetWindowText(xstring,255))
	{
		i = ListBox.GetCurSel();
		if (i == -1) i = 0;
		ListBox.GetText(i,buf);
		count = sscanf(buf,"%s %s %s",date,times,xfile,temp);
		if (count == 3)
			tt = ParseTime(buf) - 10;
		    if (tt < 0) tt = time(NULL) + 10; /* in case of error */
			tx = localtime(&tt);
			filetime = sprintf(buf,"%02d/%02d/%4d %02d:%02d:%02d %s",
					tx->tm_mon+1, tx->tm_mday, tx->tm_year+1900,
					tx->tm_hour, tx->tm_min,  tx->tm_sec, xstring);
			ListBox.InsertString(i,buf);
			FileList.SetWindowText("");

	}
	else
	{
    	FileList.ResetContent();
//		FileList.Dir(0,"data/*.*");
		OnRefresh() ;
	}
	
}

void CRTTYAppDlg::OnRefresh() 
{
WIN32_FIND_DATA  ffblk;
HANDLE firstfile;
int count;
int i;
char temp[256];
char timex[30];
char filename[256];

	// TODO: Add your control notification handler code here
	FileList.ResetContent();
//	FileList.Dir(0,"data/*.*");
	firstfile = FindFirstFile("data/*.*", &ffblk);
	count = 1;
	while (count)
	{
		if (ffblk.cFileName[0] != '.')	// rid of .. and . directory
		{
		sprintf(temp,"%d %s",50000000-ffblk.ftLastWriteTime.dwHighDateTime,
				ffblk.cFileName);
		FileList.AddString(temp);
		}
		count = FindNextFile(firstfile,&ffblk);
	}
    for (i=0; i< FileList.GetCount(); i++)
	{
		FileList.GetLBText(i, temp);
		sscanf(temp,"%s %s",timex,filename);
		FileList.DeleteString(i);
		FileList.InsertString(i,filename);
	}

	for (i=0;i<sizeofcommands;i++)
	{
			FileList.InsertString(-1,commands[i]);
	}
	
}


void CRTTYAppDlg::OnSelchangeFilelist() 
{
	char filename[255] = "";

	if (FileList.GetLBText(FileList.GetCurSel(),filename))
	{
		CanEdit.SetCheck(BF_UNCHECKED);
		OnCanEdit();
			EditDisplay.SetMargins( 0, 75);
//	EditDisplay.FmtLines(FALSE);
		PrintFile(filename);
	}
	
}

void CRTTYAppDlg::OnDiddle() 
{
	if (Diddle.GetCheck() == BF_CHECKED)
    diddleEnable = TRUE;
 else 
	diddleEnable = FALSE;
	
}

void CRTTYAppDlg::Cwid(char * mystring)
{
	int tick;
//	int soundcardid;

		localLock = TRUE;
		notSending = FALSE;
		sendNow = FALSE;		char temp[80] = "Sending CWID ";
		Log("Cwid : Sending CW Identification.");
		QueueBox.SetWindowText("CW Pre-Identification Text");
		CmTX();
		TXFile("cwid.txt",MODE);
		strcat(temp,mystring);
		QueueBox.SetWindowText(temp);

		if (MODE == psk31)
		{
			fnSetCWIDString(CWidString);
			fnSendTXCharacter(2,true);
			fnStopTX();
			tick = timerTick;
			while (timerTick-tick<15)
				GiveUp();
			fnStartTX(0);
		}
		else
		{
/*
			soundcardid = GetSoundCardID();
//			if (soundcardid > 10)
//			{
				fnStartSoundCard(m_hWnd,soundcardid,0);
				fnSetCWIDString(CWidString);
				fnSendTXCharacter(2,true);
				fnStopTX();
				fnStopSoundCard();
//			}
*/

			OnTimer(7);
			morsedelay(50);
			for (unsigned int i=0;i<strlen(mystring);i++)
				SendFSKCW(mystring[i]);
			morsedelay(50);
			OnTimer(8);
			if (tt_queue > 0)  // keeps TX from cycling between jobs
					CmRX();
		}
		QueueBox.SetWindowText("Completed CWID");
		localLock = FALSE;
		notSending = TRUE;
		sendNow = TRUE;
}

void CRTTYAppDlg::SendFSKCW(char input)
{
//int i;
 int j;
 int k;
 char in;
 int l;
 int timex;
 int MCRSave;
 int LCRSave;

   MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable 
   LCRSave = _inp(LCR+COMPORT);
   input = toupper(input);
   l = (int) (input - 32);
    if (l < 0) l = 0;
    timex = 30;
    if (morsecode[l][0] == '3')
      morsedelay(200/timex); /* inter-letter delay */
    else
    {
      for (j=0; j<5; j++)
      {
       in = morsecode[l][j];
       if (in != ' ')
       {
       k = atoi(&in);
//       	_outp(MCR+COMPORT, MCRSave | TxLine);   /*  transmit */
	   _outp(LCR+COMPORT,0x40);
       morsedelay(k*83/timex);
//       	_outp(MCR+COMPORT,MCRSave & (~TxLine&0xFF));  /* receive */
	   _outp(LCR+COMPORT,0x00);
       morsedelay(33/timex);
       }
      }
        morsedelay(200/timex);
    }
	_outp(MCR+COMPORT,MCRSave);
	_outp(LCR+COMPORT,LCRSave);
return;
}


void CRTTYAppDlg::SendMorse(char input)
{
// int i;
 int j;
 int k;
 char in;
 int l;
 int timex;
 int MCRSave;
 int LCRSave;

   MCRSave = _inp(MCR+COMPORT);      // Save Interrupt Enable 
   LCRSave = _inp(LCR+COMPORT);
   input = toupper(input);
   l = (int) (input - 32);
    if (l < 0) l = 0;
    timex = 30;
    if (morsecode[l][0] == '3')
      morsedelay(200/timex); /* inter-letter delay */
    else
    {
      for (j=0; j<5; j++)
      {
       in = morsecode[l][j];
       if (in != ' ')
       {
       k = atoi(&in);
      	_outp(MCR+COMPORT, MCRSave | TxLine);   /*  transmit */
//	   _outp(LCR+COMPORT,0x40);
       morsedelay(k*83/timex);
       	_outp(MCR+COMPORT,MCRSave & (~TxLine&0xFF));  /* receive */
//	   _outp(LCR+COMPORT,0x00);
       morsedelay(33/timex);
       }
      }
        morsedelay(200/timex);
    }
//	outp(MCR+COMPORT,MCRSave);
	_outp(LCR+COMPORT,LCRSave);
return;
}


BOOL CRTTYAppDlg::PreTranslateMessage(MSG* pMsg) 
{
    char temp[255];
	// Note: there is only one control in the toolbar that accepts keyboard input,
	// this is the combobox.
	
	// user hit ENTER
	if (pMsg->wParam == VK_RETURN && GetKeyState(VK_RETURN) < 0) 
	{
		// extract the text, update combobox lists, and do the search
 		if (pMsg->hwnd == EditSaveBox.m_hWnd) // Handle the EditDisplay Window
		{ 
			EditSaveBox.GetWindowText(temp,sizeof(temp));
			if(PrintFile(temp) == BAD)
				MessageBeep(MB_ICONEXCLAMATION);
		}
		else if (pMsg->hwnd == EditDisplay.m_hWnd)
          return CDialog::PreTranslateMessage(pMsg);		
		else
		{
			FileList.GetWindowText(temp,sizeof(temp));
			if(PrintFile(temp) == GOOD)
				OnFileadd();
			else
				MessageBeep(MB_ICONEXCLAMATION);
		}
		return TRUE;  // key processed
	}

	// do the Slider
	if ((Slider.m_hWnd == pMsg->hwnd) && (pMsg->message == WM_LBUTTONUP) && CanEdit.GetCheck())
	{
	EditDisplay.SetMargins( 0, 500-Slider.GetPos());
	EditDisplay.FmtLines(FALSE);
	}

	
	// user hit ESC
	if (pMsg->wParam == VK_ESCAPE && GetKeyState(VK_ESCAPE) < 0)
	{
		return TRUE; // key processed
	}

	// user hit DOWN-ARROW
	if (pMsg->wParam == VK_DOWN && GetKeyState(VK_DOWN) < 0 &&
		FileList.GetDroppedState() == FALSE)
	{
		FileList.ShowDropDown();
		return TRUE; // key processed
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

void CRTTYAppDlg::GiveUp()
{
// Hand resources back to the computer
MSG msg;

// 	if (msg.wParam == VK_RETURN && GetKeyState(VK_RETURN) < 0) 
//	{
//			PreTranslateMessage(&msg);
//			PeekMessage(&msg,(HWND) NULL, 0, 0,PM_REMOVE);
//	}

while (PeekMessage(&msg, (HWND) NULL, 0, 0,PM_REMOVE	)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
		}

}
//-----------------------------------------------
/* Transmits a character to the appropriate communications port   */
int CRTTYAppDlg::xmitchar(int ch)
{
  int  LSRreg;
  if (MODE == psk31)
  {
	  fnSendTXCharacter(ch,false);
	  while(fnGetTXCharsRemaining() > 2)
		  GiveUp();
  }
  else
  {
	if (m_CheckNoSoundCard.GetCheck() == BUTTON_UNCHECKED && vpProcThread != NULL)
		vpProcThread->MSK_xmit(ch);

	  do {
		  LSRreg = _inp(LSR+COMPORT) & 0x20;
		  GiveUp();
		 }  while ((LSRreg == 0) );//&& !CalcMSK_BuffEmpty);
	  _outp(RBR+COMPORT,ch);
  }
  return ch;
}



/* Open the COM port     */
void CRTTYAppDlg::OpenCom(int ComBase,
      float baud,
      int parity,
      int databits,
      int stopbits)
{
  int rate;
  int LCRreg;
  int LCRreg_old;

  COMPORT = ComBase; // Global comport ID

   // check to see test mode is set i.e. power-up
  // Doesn't trash interrupt if already set by terminal program
	if ((_inp(MCR+ComBase) & 0x10) == 0x10)
	{
	 _outp(IER+ComBase, 0x00);
	 _outp(MCR+ComBase, 0x00);
	}

  LCRreg_old = _inp(LCR+ComBase);
  LCRreg = 0x80;
  LCRreg = LCRreg | parity;
  LCRreg = LCRreg | databits;
  LCRreg = LCRreg | stopbits;
  _outp(LCR+ComBase, LCRreg);
  rate = (int) (115200.0 / baud);

  /* Load the two bytes of the register */
  _outp(DLM+ComBase, (char)((rate>>8)& 0xFF));      /* Hi byte */
  _outp(DLL+ComBase, (char)(rate     & 0xFF));      /* Low byte */

  _outp(LCR+ComBase, LCRreg & 0x7F);
//    _outp(LCR+ComBase, LCRreg_old & 0x3F);  // restore old settings

}



int CRTTYAppDlg::baudot_macro(int ch1,int MODE)
{
static bool esc_seq = FALSE;  
time_t ltime;
struct tm *today;
char temp[80],  str1[20],str2[20],str3[20];
char editsavebox[255];
int i;
		if (ch1 == '^') // set up control char for next play
		{
			esc_seq = TRUE;
			return ch1;
		}
		if (esc_seq)
		{
			esc_seq = FALSE;
			switch(ch1)
			{
			case '1':  // BELL 1 times
			case '2':  // BELL 2 times
			case '3':  // BELL 3 times
			case '4':  // BELL 4 times
			case '5':  // BELL 5 times
			case '6':  // BELL 6 times
			case '7':  // BELL 7 times
			case '8':  // BELL 8 times
			case '9':  // BELL 9 times
				temp[0] = ch1;
				temp[1] = '\0';
				if ((MODE == ascii) || (MODE == psk31))
					for (i = 0; i< atoi(temp); i++)
						xmitchar(0x7);  // Control G Bell
				else
				{
					xmitchar(FIGS);
					for (i = 0; i< atoi(temp); i++)
					xmitchar(BBEL);
					xmitchar(LTRS);
				}
				ch1 = '^';
				break;
			case 'l':
			case 'L':  // Full Local Calendar Date String
				time(&ltime);
				today = localtime( &ltime );
				strftime( temp, 80, "%B %d, %Y", today );
				for (i = 0; i < (signed)strlen(temp); i++)
				{
					if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
					SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
					sprintf(str1,"%c",temp[i]);
					strcat(editsavebox,str1);
					SendingBox.SetWindowText(editsavebox);
		
				}
				ch1 = '^';
				break;
			case 'd':
			case 'D':  // Day,month,day,year 
				time(&ltime);
				today = localtime( &ltime );
				strftime( temp, 80, "%#x", today );
				for (i = 0; i < (int)strlen(temp); i++)
				{
					if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
					SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
					sprintf(str1,"%c",temp[i]);
					strcat(editsavebox,str1);
					SendingBox.SetWindowText(editsavebox);
				}
				ch1 = '^';
				break;
			case 't':
			case 'T':  // Time String hours,minutes (PST) Local Time Zone
				time(&ltime);
				today = localtime( &ltime );
				strftime( temp, 80, "%X", today );
				temp[5] = '\0'; // remove seconds
				for (i = 0; i < (int)strlen(temp); i++)
				{
					if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
					SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
					sprintf(str1,"%c",temp[i]);
					strcat(editsavebox,str1);
					SendingBox.SetWindowText(editsavebox);
				}
					
				time(&ltime);
				today = localtime( &ltime );
				strftime(temp,80,"%Z",today);
				if (strlen(temp)) // add the shortened time zone (PST)
				{
					sscanf(temp,"%s %s %s",str1,str2,str3);
					sprintf(temp,"(%c%c%c)",str1[0],str2[0],str3[0]);
					for (i = 0; i < (int)strlen(temp); i++)
					{
						if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
						SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
						sprintf(str1,"%c",temp[i]);
						strcat(editsavebox,str1);
						SendingBox.SetWindowText(editsavebox);
					}
				}
				ch1 = '^';
				break;
			case 'w':
			case 'W': // Day of the week
				time(&ltime);
				today = localtime( &ltime );
				strftime( temp, 80, "%A", today );
				for (i = 0; i < (int)strlen(temp); i++)
				{
					if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
					SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
					sprintf(str1,"%c",temp[i]);
					strcat(editsavebox,str1);
					SendingBox.SetWindowText(editsavebox);
				}
				ch1 = '^';
				break;
			case 'u':	
			case 'U': // UTC Time  This gotta be the last in the list
				time(&ltime);
				today = gmtime( &ltime );
				strftime( temp, 80, "%X", today );
				temp[5] = '\0'; // remove seconds
				strcat(temp,"(UTC)");
				for (i = 0; i < (int)strlen(temp); i++)
				{
					if ((MODE == ascii) || (MODE == psk31))
						xmitchar(temp[i] & 0x7F);  // raw ascii transmit, mask bit8
					else
						send_baudot(temp[i],MODE);
					SendingBox.GetWindowText(editsavebox,sizeof(editsavebox));
					sprintf(str1,"%c",temp[i]);
					strcat(editsavebox,str1);
					SendingBox.SetWindowText(editsavebox);
				}
				ch1 = '^';
			default:  
				break;
			}
		}  // if escape sequence is true

	return ch1;
}


void CRTTYAppDlg::send_baudot(int ch1, int MODE)
{
int indx = 0;
char c;
int cstate;    // current state, LTRS, FIGS, BOTH (yes, three states)

  
  indx = (int) baudot_macro(ch1,MODE);
	  
  if (indx > 96) indx -= 32;      /* lower case becomes upper case  */
  if (indx >95) indx = 0;          // maximum array size, blank it out
      cstate= table3[indx].state; /* get BAUDOT case                */
      if      (MODE == ita2)
          c= table3[indx].ita2;     // ita2 protocol
      else if (MODE == telex)
          c= table3[indx].telex;    // telex protocol
      else
          c= table3[indx].military; // default military
      if (c != UU)                /* untranslatable!    */
      {
          
		  switch (c) {
			case BCR:  break;               // eat the line feed, BLF does it
			case BLF:  xmitchar(BCR);       // baudot return (unix/dos)
					   xmitchar(BCR);       // Per George Hutchinson Request
					   xmitchar(BLF);       // followed by line feed
                       xmitchar(LTRS);      // Always force LTRS per George
                       state = LTRS;
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,'\r',0);
                       break;
            case FIGS: xmitchar(FIGS);      // simple shift to FIGS
                       state= FIGS;
                       break;
            case LTRS:                       // letters
            case BSP:  xmitchar(c);          // send the letters/space char
                       if (state == FIGS)    // test the global state
                           xmitchar(LTRS);   // unshift on space
                       state = LTRS;         // set global state
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,ch1,0);
                       break;
            default:   if (state == cstate) // send cuz in proper state
                           xmitchar(c);
                       else
                       {
                         xmitchar(cstate);   // do the shift
                         xmitchar(c);        // send the character
                         state = cstate;     // set the new state	 
                       }
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,ch1,0);
                        break;
         } // case
      }    // if !UU
}



void CRTTYAppDlg::OnCWTimer() 
{
	if (CWTimerCheck.GetCheck() == BF_CHECKED)
	{
		CWTimer = 0;
		if ((transmitOn == TRUE) && !localLock)   // Starts with a CWID
			Cwid(CWidString); 
	}
	else 
	{
		CWTimer = -1;
		CWTimerDisplay.SetWindowText("OFF");
	}
}

void CRTTYAppDlg::OnPower() 
{
	if (PowerON.GetCheck() == BF_CHECKED)
	{
		CmPowerON();
	}
	else
	{
		CmPowerOFF();
	}
	
}

void CRTTYAppDlg::OnButtonsendcwid() 
{
	Cwid(CWidString);
	
}



void CRTTYAppDlg::DisplayPSK31Frequency()
{
	char temps[30];

	m_BaudGroup.SetWindowText("TX Freq");
	m_B45.SetWindowText("1500");
	m_B50.SetWindowText("1600");
	m_B56.SetWindowText("1700");
	m_B74.SetWindowText("1800");
	m_B100.SetWindowText("1900");
	m_B110.SetWindowText("2000");
	m_B300.SetWindowText("2100");
	sprintf(temps,"%10.3f",psk_freq);
	m_EditPSKFreq.SetWindowText(temps);
	sprintf(temps,"%6.2f",31.25);
	m_EditShift.SetWindowText(temps);
	m_EditShift.SetReadOnly(true);
	fnSetTXFrequency((long)psk_freq);
	sprintf(temps,"%8.1f",psk_freq - (psk_shift/2.0));
	m_EditMark.SetWindowText(temps);
	sprintf(temps,"%8.1f",psk_freq + (psk_shift/2.0));
	m_EditSpace.SetWindowText(temps);

}

void CRTTYAppDlg::DisplayRS232Mode()
{
	char temps[30];

	m_BaudGroup.SetWindowText("Mode");
	m_B45.SetWindowText( " 45.45");
	m_B50.SetWindowText( " 50.0");
	m_B56.SetWindowText( " 56.9");
	m_B74.SetWindowText( " 74.2");
	m_B100.SetWindowText("100.0");
	m_B110.SetWindowText("110.0");
	m_B300.SetWindowText("300.0");
	sprintf(temps,"%10.3f",fsk_freq);
	m_EditPSKFreq.SetWindowText(temps);
	sprintf(temps,"%8.2f",fsk_shift);
	m_EditShift.SetWindowText(temps);
	m_EditShift.SetReadOnly(false);
	sprintf(temps,"%8.1f",fsk_freq - (fsk_shift/2.0));
	m_EditMark.SetWindowText(temps);
	sprintf(temps,"%8.1f",fsk_freq + (fsk_shift/2.0));
	m_EditSpace.SetWindowText(temps);

}

void CRTTYAppDlg::ReportSoundCardError(int status)
{
	char tempstr[80];
	char tempstr1[80];

	switch (status)
	{
		case 0:  strcpy(tempstr,"No error in starting sound card process");break;
		case 10: strcpy(tempstr,"Tried to read and soundcard is not open");break;
		case 12: strcpy(tempstr,"Input buffers over-flowed");break;
		case 13: strcpy(tempstr,"Timed out waiting for input buffers");break;
		case 14: strcpy(tempstr,"Tried to write and soundcard is not open");break;
		case 15: strcpy(tempstr,"Output buffers under-flowed");break;
		case 16: strcpy(tempstr,"Timed out waiting for output buffers");break;
		case 17: strcpy(tempstr,"Card doesn't support 16bit, 8000Hz, Mono format");break;
		case 18: strcpy(tempstr,"Still something playing on soundcard");break;
		case 19: strcpy(tempstr,"Header not prepared");break;
		case 20: strcpy(tempstr,"Device is synchronous");break;
		case 21: strcpy(tempstr,"Bad Device ID, Soundcard Not Present");break;
		case 22: strcpy(tempstr,"Driver failed to enable");break;
		case 23: strcpy(tempstr,"Device already allocated");break;
		case 24: strcpy(tempstr,"Device handle is invalid");break;
		case 25: strcpy(tempstr,"No device driver present");break;
		case 26: strcpy(tempstr,"Function isn't supported");break;
		case 27: strcpy(tempstr,"Error value out of range");break;
		case 28: strcpy(tempstr,"Invalid flag passed");break;
		case 29: strcpy(tempstr,"Invalid parameter passed");break;
		case 30: strcpy(tempstr,"Handle being used");break;
		case 31: strcpy(tempstr,"Driver does not call DriverCallback");break;
		case 32: strcpy(tempstr,"Registry error");break;
		case 33: strcpy(tempstr,"Unknown Error");break;
		case 34: strcpy(tempstr,"Can't open wave file for input");break;
		case 35: strcpy(tempstr,"File is not a RIFF wave type");break;
		case 36: strcpy(tempstr,"Invalid wave file");break;
		case 37: strcpy(tempstr,"No data in file");break;
		case 38: strcpy(tempstr,"Not a supported data type");break;
		case 39: strcpy(tempstr,"Error reading data from file");break;
		case 40: strcpy(tempstr,"Tried to read and file is not open");break;
		case 41: strcpy(tempstr,"Can't open wave file for output");break;
		default: strcpy(tempstr,"Really Bad Undefined Error");break;
	}
	if (status)
	{
		sprintf(tempstr1,"(%3i) ",status);
		strcat(tempstr1,tempstr);
		MessageBox(tempstr1,"FATAL - Sound Card",MB_ICONERROR);
//		exit(-1);
	}
	else
		SendingBox.SetWindowText(tempstr);
	return;
}

void CRTTYAppDlg::OnRadiofreq1() 
{
  m_EditPSKFreq.SetReadOnly(false);
  m_EditShift.SetReadOnly(false);
  m_EditMark.SetReadOnly(true);
  m_EditSpace.SetReadOnly(true);
	
}

void CRTTYAppDlg::OnRadiofreq2() 
{
	m_EditPSKFreq.SetReadOnly(true);
  m_EditShift.SetReadOnly(true);
  m_EditMark.SetReadOnly(false);
  m_EditSpace.SetReadOnly(false);
	
}

void CRTTYAppDlg::WaitSeconds(int seconds)
{
	// Delay Timer (seconds)
	timerTick = 0;
	while ( timerTick < seconds)
	{
		GiveUp();
	}

}

void CRTTYAppDlg::OnChecknosoundcard() 
{
	if (m_CheckNoSoundCard.GetCheck())
	{
			m_EditPSKFreq.EnableWindow(false);
			m_EditShift.EnableWindow(false);
	}
	else
	{
			m_EditPSKFreq.EnableWindow(true);
			m_EditShift.EnableWindow(true);
	}
	
}

void CRTTYAppDlg::OnEditchangeCombosoundcard() 
{
	char strcard[30];
	int soundcardnum;

	m_ComboSoundCard.GetWindowText(strcard,sizeof(strcard));
	soundcardnum = atoi(strcard);
	if (soundcardnum == 0)
	{
		m_CheckNoSoundCard.SetCheck(1);
		OnChecknosoundcard();
	}
	else
	{
		m_CheckNoSoundCard.SetCheck(0);
		OnChecknosoundcard();
	}
/*	Options:
		No Sound
		-1 Auto
		1
		2
		3
		4
*/
	
}

void CRTTYAppDlg::OnSelchangeCombosoundcard() 
{
	OnEditchangeCombosoundcard();
	
}

int CRTTYAppDlg::GetSoundCardID()
{
	char strcard[30];
	int cardoption;
	m_ComboSoundCard.GetWindowText(strcard,sizeof(strcard));
/*	Options:
		No Sound
		-1 Auto
		1
		2
		3
		4
*/
	cardoption = atoi(strcard);
	switch(cardoption)
	{
	case -1: cardoption = -1; break; // Default Auto Select
	case  1: cardoption =  0; break; // Card 0
	case  2: cardoption =  1; break; // Card 1
	case  3: cardoption =  2; break; // Card 2
	case  4: cardoption =  3; break; // Card 3
	default: cardoption = 99;
		m_CheckNoSoundCard.SetCheck(0);
		break; // it will throw out the option
	}

	return cardoption;

}

void CRTTYAppDlg::MakeCallsign(char *callsign)
{
	int i;
	char temps[256];
	sprintf(CWidString,"de %s %s ",callsign,callsign);
	sprintf(AboutBoxString,"$CWID     // %s",CWidString);
	commands[12] = AboutBoxString;

	for (i=0; i < (int)strlen(callsign); i++)
	{
		WideCallsign[i*2  ] = callsign[i];  // letter
		WideCallsign[i*2+1] = ' ';			// space
	}
	sprintf(temps,"Scheduler                                                              "//eol
		"%s",WideCallsign);
	SetWindowText(temps);
	sprintf(temps,"Editor                                                            "//eol
		"%s",WideCallsign);

}


