// RTTYAppDlg.h : header file
//

#if !defined(AFX_RTTYAPPDLG_H__9B569CF8_F0E8_11D3_A248_0000C07AF277__INCLUDED_)
#define AFX_RTTYAPPDLG_H__9B569CF8_F0E8_11D3_A248_0000C07AF277__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "RTTYSchedule.h"
#include "RTTYAppDlg.h"



/////////////////////////////////////////////////////////////////////////////
// CRTTYAppDlg dialog

class CRTTYAppDlg : public CDialog
{ 
// Construction
public:
	void WaitSeconds(int seconds);
	void ReportSoundCardError(int status);
	void DisplayRS232Mode();
	void DisplayPSK31Frequency();
	void CmPowerOFF();
	void CmPowerON();
	void GiveUp();
	int xmitchar(int ch);
	void OpenCom(int ComBase,
		float baud,
		int parity,
		int databits,
		int stopbits);
	void send_baudot(int ch1, int MODE);
	int baudot_macro(int ch1,int MODE);
	void SendFSKCW(char input);
	void Cwid(char * mystring);
	void morsedelay(int xtime);
	void SendMorse(char input);
	void OnB300();
	void AddListboxItem(char * buf);
	void wdelay(int seconds);
	int PrintFile(char * fname);
	void SetMode(char * mode);
	void Availability(time_t currtime);
	void TXFile(char * fname,int MODE);
	CRTTYAppDlg(CWnd* pParent = NULL);	// standard constructor
	void Log(char * message);

	UINT	m_SampsPerSec;
	UINT	m_TimeLimit;
	int		m_OutputGroup;
	UINT	m_SinFreq;
	int		m_SourceGroup;
	INT		m_SweepRate;
	INT		m_SweepRange;
	double m_NoiseAmplitude;
	double m_SignalAmplitude;
	BOOL	m_BWLimit;


// Dialog Data
	//{{AFX_DATA(CRTTYAppDlg)
	enum { IDD = IDD_RTTYAPP_DIALOG };
	CEdit	m_EditAuthentication;
	CComboBox	m_ComboSoundCard;
	CButton	m_CheckNoSoundCard;
	CEdit	m_EditIPAddress;
	CComboBox	m_ComboIP;
	CButton	m_RadioFreq1;
	CEdit	m_EditShift;
	CEdit	m_EditPSKFreq;
	CEdit	m_EditSpace;
	CEdit	m_EditMark;
	CButton	m_BaudGroup;
	CButton	m_ModeGroup;
	CButton	m_B74;
	CButton	m_B56;
	CButton	m_B300;
	CButton	m_B110;
	CButton	m_B100;
	CButton	m_B50;
	CButton	m_B45;
	CButton	PowerON;
	CEdit	CWTimerDisplay;
	CButton	CWTimerCheck;
	CEdit	ComPort;
	CSliderCtrl	Slider;
	CButton	Diddle;
	CComboBox	FileList;
	CButton	Header;
	CEdit	SendQueueBox;
	CButton	Repeat;
	CButton	CanEdit;
	CEdit	CountDownBox;
	CEdit	AutoSendBox;
	CEdit	TransmitBox;
	CEdit	EditSaveBox;
	CEdit	EditDisplay;
	CEdit	QueueBox;
	CEdit	FlowControlBox;
	CEdit	ClockBox;
	CEdit	SendingBox;
	CListBox	ListBox;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRTTYAppDlg)
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
//protected:
public:
	void MakeCallsign(char * callsign);
	int GetSoundCardID();

	HICON m_hIcon;
	RTTYSchedule* m_pRTTYSchedule;
//	CWnd* m_pParent;

	// Generated message map functions
	//{{AFX_MSG(CRTTYAppDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMode();
	afx_msg void OnSendnext();
	afx_msg void OnReload();
	afx_msg void OnDblclkListbox();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnB45();
	afx_msg void OnB50();
	afx_msg void OnB56();
	afx_msg void OnB74();
	afx_msg void OnB100();
	afx_msg void OnB110();
	afx_msg void OnRadio1(); 
	afx_msg void OnModeMilitary();
	afx_msg void OnModeIta2();
	afx_msg void OnModeTelex();
	afx_msg void OnModeAscii();
	afx_msg void OnRyryry();
	afx_msg void OnRepeat();
	afx_msg void CmDisable();
	afx_msg void CmEnable();
	afx_msg void CmPause();
	afx_msg void CmResume();
	afx_msg void CmCancel();
	afx_msg	void OnCanEdit();
	afx_msg void CmTX();
	afx_msg void CmRX();
	afx_msg void OnThefox();
	afx_msg void OnEventlog();
	afx_msg void OnDeleteItem();
	afx_msg void OnAddItem();
	afx_msg void OnCompose();
	afx_msg void OnSend();
	afx_msg void OnSave();
	afx_msg void OnHeader();
	afx_msg void OnModeMorse();
	afx_msg void OnFileadd();
	afx_msg void OnRefresh();
	afx_msg void OnSelchangeFilelist();
	afx_msg void OnDiddle();
	afx_msg void OnCWTimer();
	afx_msg void OnPower();
	afx_msg void OnButtonsendcwid();
	afx_msg void OnModePSK31();
	afx_msg void OnRadiofreq1();
	afx_msg void OnRadiofreq2();
	afx_msg void OnChecknosoundcard();
	afx_msg void OnEditchangeCombosoundcard();
	afx_msg void OnSelchangeCombosoundcard();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RTTYAPPDLG_H__9B569CF8_F0E8_11D3_A248_0000C07AF277__INCLUDED_)
