// RTTYSchedule.cpp : implementation file
//

#include "stdafx.h"
#include "RTTYApp.h"
#include "RTTYSchedule.h"
#include "RTTYAppDlg.h"
#include <time.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TWODAYS 172800
#define GOOD 0
#define BAD 1

// Function Prototype
time_t  ParseTime(char * temp) ;

/////////////////////////////////////////////////////////////////////////////
// RTTYSchedule dialog
#define MAXSIZE 32000
char listboxtext[256];
int notimes = 1;
int showwindow = 1;
extern int sizeofcommands;
extern int deltacommands;
extern char * commands[];
extern float BAUD;
extern int MODE;
enum mode {    // not quite global, defined in main
    ascii,
	ita2,
	telex,
    military,
	psk31,
	morse
};


RTTYSchedule::RTTYSchedule(CWnd* pParent /*=NULL*/)
	: CDialog(RTTYSchedule::IDD, pParent)
{
	
	//{{AFX_DATA_INIT(RTTYSchedule)
	FilterValue = _T("");
	//}}AFX_DATA_INIT

	m_pParent = pParent;
	m_nID = RTTYSchedule::IDD;
}

void DurString(int seconds,char * timestring)
{
int xmin;
int xsec;

   if(seconds)
   {
		xmin = (int) seconds / 60;
		xsec = seconds % 60;
		sprintf(timestring,"%4d:%02d",xmin,xsec);
   }
   else
	   timestring[0] = '\0';

}



void RTTYSchedule::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RTTYSchedule)
	DDX_Control(pDX, IDC_MODIFIED, Modified);
	DDX_Control(pDX, IDC_SLIDER1, Slider);
	DDX_Control(pDX, IDC_EDITDUR, EditDur);
	DDX_Control(pDX, IDC_FILTER, Filter);
	DDX_Control(pDX, IDC_EDIT1, EditDisplay);
	DDX_Control(pDX, IDC_EDITSAVEBOX, EditSaveBox);
	DDX_Control(pDX, IDC_CANEDIT1, CanEdit);
	DDX_Control(pDX, IDC_AUTOTIME, AutoTime);
	DDX_Control(pDX, IDC_FILELIST, FileList);
	DDX_Control(pDX, IDC_LISTBOX, ListBox);
	DDX_Control(pDX, IDC_TIME, ScheduleTime);
	DDX_Control(pDX, IDC_DATE, ScheduleDate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(RTTYSchedule, CDialog)
	//{{AFX_MSG_MAP(RTTYSchedule)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_INSERTAT, OnInsertat)
	ON_LBN_DBLCLK(IDC_LISTBOX, OnDblclkListbox)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_REPLACE, OnReplace)
	ON_BN_CLICKED(IDC_AUTOTIME, OnAutotime)
	ON_BN_CLICKED(IDC_CANEDIT1, OnCanedit)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_CBN_DROPDOWN(IDC_FILELIST, OnDropdownFilelist)
	ON_CBN_SELCHANGE(IDC_FILELIST, OnSelchangeFilelist)
	ON_BN_CLICKED(IDC_SaveSchedule, OnSaveSchedule)
	ON_BN_CLICKED(IDC_EDITCLEAR, OnEditclear)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER1, OnReleasedcaptureSlider1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// RTTYSchedule message handlers


void RTTYSchedule::OnOK() 
{

	RTTYSchedule::Save("data/schedule.lst");
	showwindow = 1;
	CDialog::OnOK();
}

void RTTYSchedule::OnCancel() 
{
	// TODO: Add extra cleanup here
	showwindow = 1;
	CDialog::OnCancel();
}



void RTTYSchedule::OnShowWindow(BOOL bShow, UINT nStatus) 
{		
	if (showwindow)
	{	
		showwindow = 0;
		RTTYSchedule::Load("data/schedule.lst");
		Filter.SetWindowText("*.txt");
		FileDirectory();
		RTTYSchedule::SendMessage(WM_SYSCOMMAND,SC_RESTORE,0);
		Slider.SetRange( 0, 500, FALSE );
		Slider.SetPos(425);
		EditDisplay.SetMargins(0,75);
		EditSaveBox.SetWindowText("");
	}
}



void RTTYSchedule::OnInsertat() 
{
	// TODO: Add your control notification handler code here
	char xstring[25];
int i;
char buf[255];
char xdate[255] = "";
char xtime[255] = "";
char xfile[255] = "";
char temp[255];
int count;
int filetime = 1;
time_t tt;
tm *tx;

	if (FileList.GetWindowText(xstring,80))
	{
		i = ListBox.GetCurSel();
		if (i == -1) i = 0;
		ListBox.GetText(i,buf);
        if (ScheduleDate.GetWindowText(xdate,sizeof(xdate)) &&
		ScheduleTime.GetWindowText(xtime,sizeof(xtime)))
		{
			count = sscanf(buf,"%s %s %s",temp,temp,xfile,temp);
			sprintf(buf,"%s %s",xdate,xtime);
//			ListBox.InsertString(0,buf);
		}
		else
			count = sscanf(buf,"%s %s %s",xdate,xtime,xfile,temp);
		if (count == 3)
			if (!notimes)
			{
			tt = ParseTime(buf);
		    if (tt < 0) tt = time(NULL) + 10; /* in case of error */
			tx = localtime(&tt);
			filetime = sprintf(buf,"%02d/%02d/%4d  %02d:%02d:%02d  %s",
					tx->tm_mon+1, tx->tm_mday, tx->tm_year+1900,
					tx->tm_hour, tx->tm_min,  tx->tm_sec, xstring);
			ListBox.InsertString(i,buf);
			FileList.SetWindowText("");
			}
			else
			{
				ScheduleDate.GetWindowText(xdate,sizeof(xdate));
				ScheduleTime.GetWindowText(xtime,sizeof(xtime));
				FileList.GetWindowText(xfile,sizeof(xfile));
				if (strchr(xtime,':'))
					sprintf(buf,"%10s  %8st  %s",xdate,xtime,xfile);
				else
					sprintf(buf,"%10s  %8s  %s",xdate,xtime,xfile);
				ListBox.InsertString(i,buf);
				FileList.SetWindowText("");
			}

	}
	else
	FileDirectory();
	Save("data/schedule.tmp");
	Load("data/schedule.tmp");
	
}

void RTTYSchedule::Save(char * filename)
{
	char xdate[255];
	char xtime[255];
	char xfile[255];
	FILE *out;
	char temp[255];

	int i;
//  int size;
	
	// TODO: Add extra validation here
//	ScheduleDate.GetWindowText(date,sizeof(date));
//	ScheduleTime.GetWindowText(xtime,sizeof(xtime));
//	ScheduleAdd.GetWindowText(filename,sizeof(filename));
//	sprintf(listboxtext,"%s %s %s",date,xtime,filename);
			if ((out = fopen(filename,"w")) == NULL)
			{
				//SendingBox.SetWindowText("Cannot open LOG file,check for LOG directory.");
				return;
			}
			for (i=0;i<ListBox.GetCount();i++)
			{
			ListBox.GetText(i,temp);			
			if (temp[0] == ' ')
			{
				sscanf(temp,"%s",xfile);
				strcat(xfile,"\n"); 
				fputs(xfile,out);
			}
			else
			{
			   sscanf(temp,"%s %s %s",xdate,xtime,xfile);
			   if (strchr(xtime,'t'))
			   {
				   xtime[8] = '\0';
				   sprintf(temp,"%s\t%s\t%s\n",xdate,xtime,xfile);
			   }
			   else					
					sprintf(temp,"%s\n",xfile);
			  fputs(temp,out);
			 }
			}			
			fclose(out);
}



void RTTYSchedule::OnDblclkListbox() 
{
	// TODO: Add your control notification handler code here
char xdate[255];
char xtime[255];
char xfile[255];
char buf[255];
int i;


	i = ListBox.GetCurSel();
	ListBox.GetText(i,buf);
	sscanf(buf,"%s %s %s",xdate,xtime,xfile);
	if (buf[0] == ' ')
	{
		FileList.SetWindowText(xdate);
		ScheduleDate.SetWindowText("");
		ScheduleTime.SetWindowText("");
		CanEdit.SetCheck(0);
		OnCanedit() ;
		PrintFile(xdate);
	}
	else
	{
		FileList.SetWindowText(xfile);
		if (strchr(xtime,'t'))
		{
			ScheduleDate.SetWindowText(xdate);
			ScheduleTime.SetWindowText(xtime);
		}
		else
		{
			ScheduleDate.SetWindowText("");
			ScheduleTime.SetWindowText("");
		}
		CanEdit.SetCheck(0);
		OnCanedit();
		PrintFile(xfile);
	}
}

void RTTYSchedule::OnDelete() 
{
	ListBox.DeleteString(ListBox.GetCurSel());	
}

void RTTYSchedule::OnReplace() 
{
char xdate[255] = "";
char xtime[255] = "";
char xfile[255] = "";
char buf[255] = "";
int xline;

	// TODO: Add your control notification handler code here
	
	xline =   ListBox.GetCurSel(); 
	ListBox.DeleteString(xline);
	ScheduleDate.GetWindowText(xdate,sizeof(xdate));
	ScheduleTime.GetWindowText(xtime,sizeof(xtime));
	FileList.GetWindowText(xfile,sizeof(xfile));
	if (strchr(xtime,':'))
		sprintf(buf,"%10s  %8st  %s",xdate,xtime,xfile);
	else
		sprintf(buf,"%10s  %8s  %s",xdate,xtime,xfile);
	ListBox.InsertString(xline,buf);
	Save("data/schedule.tmp");
	Load("data/schedule.tmp");
	
}




void RTTYSchedule::OnAutotime() 
{
	// TODO: Add your control notification handler code here
    Save("data/schedule.tmp");

	Load("data/schedule.tmp");
	
}

void RTTYSchedule::Load(char * schedulefilename)
{
//	char xtime[255];
	char xstring[255] = "";
    char temp[255] = "";
	FILE *in;
	char date[255] = "";
	char times[255] = "";
	char xfile[255] = "";
	int count;
	static time_t tt;
	static time_t tt_input;
	tm *tx;
	char filename[255];
    unsigned int i;
    unsigned int buflen;
	CFileFind finder;
	int filetime = 1;
	static float localbaud = (float)45.45;
	static float sbaud = (float)0.165;
//	WIN32_FIND_DATA  ffblk;
//	HANDLE firstfile;
	char timestring[10];
	extern float psk_freq;

	if (AutoTime.GetCheck())
	   notimes = 0;
	else
	   notimes = 1;
	
	ListBox.ResetContent();
		
	if ((in = fopen(schedulefilename, "rt"))
							== NULL)
	{
//			Log("GetSchedule : Cannot open Schedule.lst input file.");
			return;
	}

   time(&tt);   // Start time of run and for case where count == 1
   tt += 10;    // Make sure first entry is greater than current time
   while (!feof(in))
   {
       strcpy(xstring,"(null)");
	   if( fgets(xstring, 80, in) != NULL)
       {
         count = sscanf(xstring,"%s %s %s",date,times,xfile);
         buflen = strlen(xstring);
         xstring[buflen-1] = '\0';
         for (i=0; i<buflen;i++)
               if (xstring[i] == '\t')
         xstring[i] = ' ';

         // Calculate baud rate
		 if (count == 1)
		 {

           strncpy(temp,xfile,80);

		 }
		 else
			 strncpy(temp,date,80);
		 for (i=0; i<strlen(temp); i++)
                      temp[i] = toupper(temp[i]);
				if (strncmp(temp,"$B45",4) == 0) // Baud Baud 45.45
					localbaud = (float)45.45;
				else if (strncmp(temp,"$B50",4) == 0) // Baud 50.0
					localbaud = (float)50.0;
				else if (strncmp(temp,"$B56",4) == 0) // Baud 56.9
					localbaud = (float)56.9;
				else if (strncmp(temp,"$B74",4) == 0) // Baud 74.4
					localbaud = (float)74.4;
				else if (strncmp(temp,"$B10",4) == 0) // Buad 100.0
					localbaud = (float)100.0;
				else if (strncmp(temp,"$B11",4) == 0) // Baud 110.0
					localbaud = (float)110.0;
				else if (strncmp(temp,"$B30",4) == 0) // Baud 300.0
					localbaud = (float)300.0;
				else if (strncmp(temp,"$F15",4) == 0) // Baud Baud 45.45
					psk_freq = (float)1500.0;
				else if (strncmp(temp,"$F16",4) == 0) // Baud 50.0
					psk_freq = (float)1600.0;
				else if (strncmp(temp,"$F17",4) == 0) // Baud 56.9
					psk_freq = (float)1700.0;
				else if (strncmp(temp,"$F18",4) == 0) // Baud 74.4
					psk_freq = (float)1600.0;
				else if (strncmp(temp,"$F19",4) == 0) // Buad 100.0
					psk_freq = (float)1900.0;
				else if (strncmp(temp,"$F20",4) == 0) // Baud 110.0
					psk_freq = (float)2000.0;
				else if (strncmp(temp,"$F21",4) == 0) // Baud 300.0
					psk_freq = (float)2100.0;

	       if (MODE == ascii)
			   sbaud = (float)(10.0 / localbaud);
		   else if (MODE == psk31)
			   sbaud = (float)(10.0/40.0);
		   else
			   sbaud = (float)(7.5 / localbaud);

         // got a file-only input, Georges special request
		 // time test is only used if first entry in input file
         if (count == 1)
		 {
			 if (tt > (time(NULL) - TWODAYS))
			 {	
				tt = tt + (long)(filetime * sbaud);
				
				strcpy(xfile,"data/");
				strcat(xfile,xstring);
				BOOL bWorking = finder.FindFile(xfile);
			    if (bWorking)
				{
			 	   bWorking = finder.FindNextFile();
                   filetime = finder.GetLength();
				}
				else
					filetime = 0;
				if (filetime == 0)
				{
					if (date[0] == '$')
					{
						sprintf(temp,"%-35s %s",date,"CMD");
						filetime = 1;
					}
					else
						sprintf(temp,"%-35s %s",date,"???");
					strcpy(date,temp);
					
				}
				tx = localtime(&tt);
				DurString((int)(filetime*sbaud),timestring);
				if (notimes)
							count = 
				sprintf(temp,"                      %-40s  %5d %9s",
					date,filetime,timestring);
				else
					count = sprintf(temp,"%02d/%02d/%4d  %02d:%02d:%02d  %-40s  %5d %9s",
					tx->tm_mon+1, tx->tm_mday, tx->tm_year+1900,
					tx->tm_hour, tx->tm_min,  tx->tm_sec, date,filetime,timestring);
				ListBox.AddString(temp);
			}
			else   // default expired time tag case count == 1
			{
				sprintf(temp,
				 "GetSchedule : Expired time tag %s",
                xstring);
////			 Log(temp);
			}
		 } // end case count == 1
         // Got a date, remember it for case were count == 1
		 else if (count == 3) 
		 {
			 tt_input = ParseTime(xstring);
			 if (tt_input > 0)
				 tt = tt_input;
			// Got a date, time,file sequence
			if (tt_input > (time(NULL) - TWODAYS))   // Two Days Prior
			{
				
				sprintf(filename,"data/%s",xfile);
				BOOL bWorking = finder.FindFile(filename);
			    if (bWorking)
				{
			 	   bWorking = finder.FindNextFile();
                   filetime = finder.GetLength();
				}
				if (filetime == 0)
				{
					if (xfile[0] == '$')
					{
						sprintf(temp,"%-21s %s",xfile,"CMD");
						filetime = 1;
					}
					else
						sprintf(temp,"%-21s %s",xfile,"???");
					strcpy(xfile,temp);
					
				}
				tt = tt_input; // new start time for run
//				sprintf(temp,"%s  %st %-40s  %5d %5.f",
//					 date,times, xfile,filetime,filetime/(1000/localbaud/4.0));
				DurString((int)(filetime*sbaud),timestring);
				sprintf(temp,"%s  %st %-40s  %5d %9s",
					 date,times, xfile,filetime,timestring); 
				ListBox.AddString(temp);

			}
			else   // default expired time tag
			{
				sprintf(temp,
					"GetSchedule : Expired time tag %s",
                xstring);
//				Log(temp);
			}
		 } // count == 3
		 //else invalid entry, but will skip comment
	   }
	}
   fclose(in);
//   FileList.ResetContent();
//   FileList.Dir(0,"data/*.*");
	FileDirectory();
}

void RTTYSchedule::OnCanedit() 
{
	if (CanEdit.GetCheck())
	{
		EditDisplay.SetReadOnly(FALSE);
		EditSaveBox.SetReadOnly(FALSE);
		EditDisplay.SetMargins( 0,75);
		Slider.SetPos(425);
	}
 else
	{
		EditDisplay.SetMargins(0,0);
		Slider.SetPos(500);
		EditDisplay.SetReadOnly(TRUE);
		EditSaveBox.SetReadOnly(TRUE);
	}	
}



int RTTYSchedule::PrintFile(char * fname)
{
char xstring[255] = "";
char * buf;
FILE *in;
char filename[255] = "data\\";
//unsigned int i;
//unsigned int len;
CFileFind finder;
//WIN32_FIND_DATA  ffblk;
//HANDLE firstfile;
int filetime = 0;
char timestring[10];

   
		EditSaveBox.SetWindowText(fname);
		CanEdit.SetCheck(0);
//		Char66.SetCheck(FALSE);
		strcat(filename,fname);
		BOOL bWorking = finder.FindFile(filename);
		if (bWorking)
		{
			bWorking = finder.FindNextFile();
            filetime = finder.GetLength();
		}
		DurString((int)(filetime/(1000/45.45/4.0)),timestring);
		EditDur.SetWindowText(timestring);
		if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
		{
			EditDisplay.SetWindowText(
				"PrintFile : Not enough memory to allocate buffer\n");
			return 1;  /* terminate program if out of memory */
		}
		if ((in = fopen(filename, "rb"))== NULL)
		{
			sprintf(xstring,"[PrintFile :Cannot open %s input file.]",fname);
			EditDisplay.SetWindowText(xstring);
			return 1;
		}
		fread(buf, MAXSIZE-2, 1, in);  // must allow for null termination
		EditDisplay.SetWindowText(buf);
		fclose(in);
		free(buf);
   return 0;
}


 

void RTTYSchedule::OnSave() 
{
FILE *out;
char * buf;
char fname[255] = "data\\";
char temp[255];


	EditDisplay.FmtLines(TRUE);	// Saves the formatted soft CR stuff
	if ((buf = (char *) calloc(1,MAXSIZE)) == NULL)
	{
		EditDisplay.SetWindowText(
			"PrintFile : Not enough memory to allocate CmCompose buffer\n");
		return;  /* terminate program if out of memory */
	}
	EditDisplay.GetWindowText(buf,MAXSIZE);
	EditSaveBox.GetWindowText(temp,sizeof(temp));
	strcat(fname,temp);
	if ((out = fopen(fname,"wb")) == NULL)
	{
		sprintf(temp,"CmEditSave : Cannot open <%s> file",fname);
		EditDisplay.SetWindowText(temp);
		return;
	}
	fputs(buf,out);
	fclose(out);
	free(buf);
	FileDirectory();

}
void RTTYSchedule::FileDirectory()
{
	WIN32_FIND_DATA  ffblk;
	HANDLE firstfile;
	CFileFind finder;
	int count = 0;
	int total = 0;
	char filter[30] = "";
	char filterstring[80] = "data\\";
	int i;
	char temp[255];
	char timex[80];
	char filename[256];

   FileList.ResetContent();
   Filter.GetWindowText(filter,sizeof(filter));
   strcat(filterstring,filter);
   firstfile = FindFirstFile(filterstring, &ffblk);
   if (firstfile != INVALID_HANDLE_VALUE)
   {
	count = 1;
	total++;
	while (count)
	{
		if (ffblk.cFileName[0] != '.')	// rid of .. and . directory
		{
			if (Modified.GetCheck())
			{
				sprintf(temp,"%d %s",50000000-ffblk.ftLastWriteTime.dwHighDateTime,
					ffblk.cFileName);
				FileList.AddString(temp);
			}
			else
				FileList.AddString(ffblk.cFileName);
		}
	   count = FindNextFile(firstfile,&ffblk);
	   if (count) total++;
	}
   }
	if (Modified.GetCheck())
	{
		for (i=0; i< FileList.GetCount(); i++)
		{
			FileList.GetLBText(i, temp);
			sscanf(temp,"%s %s",timex,filename);
			FileList.DeleteString(i);
			FileList.InsertString(i,filename);
		}
	}


   if (total == 0)
	   FileList.SetWindowText("$ ***** No Files Found *****");
   for (i=0;i<sizeofcommands+deltacommands;i++)
   {
		FileList.InsertString(-1,commands[i]);
   }
}




void RTTYSchedule::OnDropdownFilelist() 
{

	FileDirectory();
	
}



void RTTYSchedule::OnSelchangeFilelist() 
{
	char temp[255] = "";

	FileList.GetLBText(FileList.GetCurSel(),temp);	
	if (strlen(temp))
	{
		CanEdit.SetCheck(0);
//		Char66.SetCheck(FALSE);
		OnCanedit() ;
		PrintFile(temp);
	}
	
}

void RTTYSchedule::OnSaveSchedule() 
{
Save("data/schedule.lst");
	
}




void RTTYSchedule::OnEditclear() 
{
	EditDisplay.SetMargins(0,0);
	Slider.SetPos(500);
	EditDisplay.SetWindowText("");
	EditDisplay.SetReadOnly(TRUE);
	EditSaveBox.SetWindowText("");
	EditSaveBox.SetReadOnly(TRUE);
	CanEdit.SetCheck(FALSE);
	EditDur.SetWindowText("");
	
}


BOOL RTTYSchedule::PreTranslateMessage(MSG* pMsg) 
{
		char s1[255] = "";
	// Note: there is only one control in the toolbar that accepts keyboard input,
	// this is the combobox.
	
	// user hit ENTER
	if (pMsg->wParam == VK_RETURN && GetKeyState(VK_RETURN) < 0)
	{

	if (pMsg->hwnd == EditDisplay.m_hWnd)
		return CDialog::PreTranslateMessage(pMsg);
		// extract the text, update combobox lists, and do the search
		// VC++ Version 5.0 will not allow me to test for FileList
//		if (pMsg->hwnd != EditDisplay.m_hWnd) // Handle the CComboBox Edit Window
//		{
//			FileList.GetWindowText(s1,sizeof(s1));
//			if(strlen(s1))
//			{
//				CanEdit.SetCheck(0);
//				OnCanedit() ;
//				PrintFile(s1);
//				return TRUE;  // key processed
//			}
//			else
//			{
//				MessageBeep(MB_ICONEXCLAMATION);
//				return TRUE;  // key processed
//			}
//		}

		// extract the text, update combobox lists, and do the search
 		if (pMsg->hwnd == EditSaveBox.m_hWnd) // Handle the EditDisplay Window
		{ 
			EditSaveBox.GetWindowText(s1,sizeof(s1));
			if(PrintFile(s1) == BAD)
				MessageBeep(MB_ICONEXCLAMATION);
		}
		else
		{
			FileList.GetWindowText(s1,sizeof(s1));
			if(PrintFile(s1) == GOOD)
				OnSelchangeFilelist();
			else
				MessageBeep(MB_ICONEXCLAMATION);
		}
		return TRUE;  // key processed


	}
// do the Slider
//	if (Slider.m_hWnd == pMsg->hwnd)
//	{
//		if	(pMsg->message == WM_LBUTTONUP)
//		{
//			if (CanEdit.GetCheck())
//			{
//				EditDisplay.SetMargins( 0, 500-Slider.GetPos());
//				EditDisplay.FmtLines(FALSE);
//			}
//		}
//	}

	// user hit ESC
	if (pMsg->wParam == VK_ESCAPE && GetKeyState(VK_ESCAPE) < 0)
	{
//		GetApplicationView()->SetFocus();
		return TRUE; // key processed
	}

	// user hit DOWN-ARROW
	if (pMsg->wParam == VK_DOWN && GetKeyState(VK_DOWN) < 0 &&
		FileList.GetDroppedState() == FALSE)
	{
		FileList.ShowDropDown();
		return TRUE; // key processed
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void RTTYSchedule::OnRefresh() 
{
	CanEdit.SetCheck(TRUE);
//	Char66.SetCheck(TRUE);
//	OnCanedit() ;
	EditDisplay.SetMargins( 0, 500-Slider.GetPos());
	EditDisplay.FmtLines(FALSE);

	
}


BOOL RTTYSchedule::Create()
{
	return CDialog::Create(m_nID, m_pParent);

}

void RTTYSchedule::OnReleasedcaptureSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (CanEdit.GetCheck())
	{
		EditDisplay.SetMargins( 0, 500-Slider.GetPos());
		EditDisplay.FmtLines(FALSE);
	}
	*pResult = 0;
}

BOOL RTTYSchedule::OnInitDialog() 
{
	extern char WideCallsign[];

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	char temps[256];
	sprintf(temps,"Editor                                                            "//eol
		"%s",WideCallsign);
	SetWindowText(temps);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
