 //#include <dos.h>
#include <conio.h>
#include "defines.h"
#include "codes.h"
#include <sys/types.h>
#include <windows.h>
//#include <winsock.h>


enum mode {    // not quite global, defined in main
    ascii,
	ita2,
	telex,
    military,
	psk31,
	morse
};

extern int COMPORT;





/* Open the COM port     */
void OpenCom(int ComBase,
      float baud,
      int parity,
      int databits,
      int stopbits)
{
  int rate;
  int LCRreg;
  int LCRreg_old;

  COMPORT = ComBase; // Global comport ID

   // check to see test mode is set i.e. power-up
  // Doesn't trash interrupt if already set by terminal program
	if ((_inp(MCR+ComBase) & 0x10) == 0x10)
	{
	 _outp(IER+ComBase, 0x00);
	 _outp(MCR+ComBase, 0x00);
	}

  LCRreg_old = _inp(LCR+ComBase);
  LCRreg = 0x80;
  LCRreg = LCRreg | parity;
  LCRreg = LCRreg | databits;
  LCRreg = LCRreg | stopbits;
  _outp(LCR+ComBase, LCRreg);
  rate = (int) 115200.0 / baud;

  /* Load the two bytes of the register */
  _outp(DLM+ComBase, (char)((rate>>8)& 0xFF));      /* Hi byte */
  _outp(DLL+ComBase, (char)(rate     & 0xFF));      /* Low byte */

  _outp(LCR+ComBase, LCRreg & 0x7F);
//    _outp(LCR+ComBase, LCRreg_old & 0x3F);  // restore old settings

}

void GiveUp() {  // Hand resources back to the computer
MSG msg;

while (PeekMessage(&msg, (HWND) NULL, 0, 0,PM_REMOVE	)) {

	if (msg.wParam == VK_RETURN && GetKeyState(VK_RETURN) < 0) 
	{
		continue;
	}
				TranslateMessage(&msg);
				DispatchMessage(&msg);
		}
}

/* Transmits a character to the appropriate communications port   
int xmitchar(int ch)
{
  int  LSRreg;
  do {
      LSRreg = _inp(LSR+COMPORT) & 0x20;
      GiveUp();
     }  while (LSRreg == 0);
  _outp(RBR+COMPORT,ch);
  return ch;
}
*/
/*
void baudot_macro(int ch1,int MODE)
{
	switch (MODE)
	{
	case military :
	case ita2:
	case telex: if (ch1 == '^')
				{ 
					 xmitchar(FIGS);
					 xmitchar(BBEL);
					 xmitchar(LTRS);
				}
		break;
	default: // nothing 
		break;
	}
}
*/

void send_baudot(int ch1, int MODE)
{
int indx = 0;
char c;
int cstate;    // current state, LTRS, FIGS, BOTH (yes, three states)

  
	   indx = (int) baudot_macro(ch1,MODE);

      if (indx > 96) indx -= 32;      /* lower case becomes upper case  */
      if (indx >95) indx = 0;          // maximum array size, blank it out
       cstate= table3[indx].state; /* get BAUDOT case                */
      if      (MODE == ita2)
          c= table3[indx].ita2;     // ita2 protocol
      else if (MODE == telex)
          c= table3[indx].telex;    // telex protocol
      else
          c= table3[indx].military; // default military
      if (c != UU)                /* untranslatable!    */
      {
          
		  switch (c) {
			case BCR:  break;               // eat the line feed, BLF does it
			case BLF:  xmitchar(BCR);       // baudot return (unix/dos)
					   xmitchar(BCR);       // Per George Hutchinson Request
					   xmitchar(BLF);       // followed by line feed
                       xmitchar(LTRS);      // Always force LTRS per George
                       state = LTRS;
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,'\r',0);
                       break;
            case FIGS: xmitchar(FIGS);      // simple shift to FIGS
                       state= FIGS;
                       break;
            case LTRS:                       // letters
            case BSP:  xmitchar(c);          // send the letters/space char
                       if (state == FIGS)    // test the global state
                           xmitchar(LTRS);   // unshift on space
                       state = LTRS;         // set global state
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,ch1,0);
                       break;
            default:   if (state == cstate) // send cuz in proper state
                           xmitchar(c);
                       else
                       {
                         xmitchar(cstate);   // do the shift
                         xmitchar(c);        // send the character
                         state = cstate;     // set the new state	 
                       }
					   xPostMessage(HWND_BROADCAST ,WM_MSGPORT00,ch1,0);
                        break;
         } // case
      }    // if !UU
}

// both character set is NULL LF CR FIGS LTRS SPACE

/* finis */
