//////////////////////////////////////////////////////////////////////
// Generators.h: interface for the CGenerators class.
//
//////////////////////////////////////////////////////////////////////
//SoundCard/Wavefile signal generator program
// Copyright 1999.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_GENERATORS_H__5D368241_6BE2_11D2_88B9_444553540000__INCLUDED_)
#define AFX_GENERATORS_H__5D368241_6BE2_11D2_88B9_444553540000__INCLUDED_

#include <afxmt.h>


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define BPFIR_LENGTH 59

class CGenerators  
{
public:
// random generators
	void Uniform(double* pData , INT n);
	void Gaussian(double * pData, INT n, double std);
// sin generator
	void InitNCO(INT Fs, double freq, INT rate, INT range);
	void CalcNCO( double* pData , INT n );
	void AddBWLimitedNoise(INT bufsize, double *pIn,
				double siggain,double RMSlevel, BOOL useFilter);

	CGenerators();
	virtual ~CGenerators();

private:
	double m_DopplerRange;
	double m_DopplerRate;
	double m_DeltaPerSecSec;
	double m_SecPerSamp;
	BOOL m_DopplerUP;
	double m_DopplerInc;
	double m_2PI;
// sin generator variables
	double m_NCOPhaseInc;
	double m_NCOPhaseInc1;
	double m_NCOPhaseInc2;
	double m_NCOPhaseInc3;
	double m_NCOPhaseInc4;
	double m_pQue[BPFIR_LENGTH];
	INT m_FirState;
};

#endif // !defined(AFX_GENERATORS_H__5D368241_6BE2_11D2_88B9_444553540000__INCLUDED_)
