// Telnet.cpp : implementation file
//

#include "stdafx.h"
#include "Telnet.h"
#include "RTTYApp.h"
#include "RTTYAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern Telnet * m_pConnectSocket;
Telnet * m_pListenSocket;
extern CRTTYAppDlg *m_RTTYAppDlg;
//Telnet * m_pListenSocket;

/////////////////////////////////////////////////////////////////////////////
// Telnet

Telnet::Telnet()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		exit(-1);
	}
	m_NetStatus = NET_OFF;
	m_ReadLine = "";
	m_Echo = false;

}

Telnet::~Telnet()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(Telnet, CAsyncSocket)
	//{{AFX_MSG_MAP(Telnet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// Telnet member functions


void Telnet::OnAccept(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	UINT port;
	CString sPeer;

	if (m_pListenSocket->m_NetStatus == NET_CONNECTED)
	{
		// Create a rejection socket
		CAsyncSocket sRjctSock;
		// Create a message to send
		m_pConnectSocket->GetPeerName( sPeer, port );
		CString strMsg = "Port already has connection from ["+ m_ConnectedPeer + "] \n\r Connection Reset";
		// Accept using the rejection socket
		Accept(sRjctSock);
		// Send the rejection message
		sRjctSock.Send(LPCTSTR(strMsg), strMsg.GetLength());
		// Close the socket
		sRjctSock.Close();
	}
	else
	{
		// Accept the connection request
		if ( Accept( *m_pConnectSocket ) )
		{
			m_pConnectSocket->AsyncSelect( FD_READ|FD_CLOSE );
		}
		m_pListenSocket->m_NetStatus = NET_CONNECTED;
		m_pConnectSocket->m_NetStatus = NET_CONNECTED;
		if( m_pConnectSocket->GetPeerName( sPeer, port ) )
			m_ConnectedPeer = sPeer;
		else
			m_ConnectedPeer = "Unknown Peer";
	}
}

void Telnet::OnConnect(int nErrorCode) 
{
	char authentication_string[256];
	int status;

	CAsyncSocket::OnConnect(nErrorCode);
	m_RTTYAppDlg->m_EditAuthentication.GetWindowText(authentication_string,sizeof(authentication_string));
	strcat (authentication_string,"\n\n");
	m_NetStatus = NET_CONNECTED;
	status = Send(authentication_string,strlen(authentication_string),0);
	if (status > 0)
	{
		m_RTTYAppDlg->m_EditAuthentication.SetReadOnly(true);
		m_RTTYAppDlg->m_EditIPAddress.SetReadOnly(true);
		m_RTTYAppDlg->m_ComboIP.EnableWindow(false);
		m_RTTYAppDlg->m_ComboSoundCard.EnableWindow(false);
		m_RTTYAppDlg->CmResume();
	}
	else
		MessageBox(NULL,"Error with Sending to Socket","Socket Error",MB_ICONERROR);

}

void Telnet::OnClose(int nErrorCode) 
{
	m_NetStatus = NET_OFF; // tell listerner not to accept any more connections
	m_ReadLine = "";
//	m_RTTYAppDlg->m_EditIPAddress.SetReadOnly(false);
//	m_RTTYAppDlg->m_ComboIP.EnableWindow(true);
//	m_RTTYAppDlg->m_ComboSoundCard.EnableWindow(true);
	m_RTTYAppDlg->CmRX();
	m_RTTYAppDlg->CmPause();

//	m_NetStatus = NET_LISTENING;
	
	if (m_hSocket != INVALID_SOCKET)
		CAsyncSocket::OnClose(nErrorCode);
	if (m_hSocket != INVALID_SOCKET)
		Detach();
}

void Telnet::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	BYTE pBuf[1024];

	int count = 0;
	count = Receive(pBuf,1024,0);
	if (m_Echo)
		Send(LPCTSTR(pBuf),count,0);

	pBuf[count] = '\0';
	m_ReadLine += LPCTSTR(pBuf);
	count = m_ReadLine.Find('\n');
	if (count > 0)
	{
//		ptr_CSocketTestDlg->m_Print.AddString(m_ReadLine.Left(count-1));
		m_ReadLine = m_ReadLine.Mid(count+1);
	}
	if (count == 0)
		m_ReadLine.Empty();
}

void Telnet::OnSend(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	CAsyncSocket::OnSend(nErrorCode);
}

bool Telnet::StartSocketListen(short m_NetSocket)
{
	int status;
	Create(m_NetSocket, SOCK_STREAM, FD_READ | FD_WRITE | FD_ACCEPT | FD_CONNECT | FD_CLOSE);
	if(status = GetLastError() != 0)
	{
		m_NetStatus = NET_ERROR;
		return true;
	}
	Listen();
	if(status = GetLastError() != 0)
	{
		m_NetStatus = NET_ERROR;
		return true;
	}
	m_NetStatus = NET_LISTENING;
		

	return false;
}

bool Telnet::StartSocketConnect(LPCTSTR lpszHostAddress, UINT nHostPort)
{
	int status;

	if (FromHandle(m_hSocket) == NULL)
	{
		Create(0, SOCK_STREAM, FD_READ | FD_WRITE | FD_CONNECT | FD_CLOSE);
//		Create();
		if(status = GetLastError() != 0)
		{
			m_NetStatus = NET_ERROR;
			return true;
		}
		status = Connect(lpszHostAddress,nHostPort);
		if (status == 0)
		{
			status = GetLastError();
			if (status != WSAEWOULDBLOCK )
			{
				m_NetStatus = NET_OFF;
				return true;
			}
			else
				return false;
		}
		else
			return false;
	}
	else
	{
		m_NetStatus = NET_OFF;
		return true;
	}
}


int Telnet::Receive(void* lpBuf, int nBufLen, int nFlags) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CAsyncSocket::Receive(lpBuf, nBufLen, nFlags);
}

int Telnet::Send(const void* lpBuf, int nBufLen, int nFlags) 
{
	int iSent;
	int sent;
	sent = 0;
	char str[256];
	int status = 0;

	if (m_NetStatus != NET_CONNECTED)
		return -1;

	if (m_hSocket == INVALID_SOCKET)
		return -1;

	while(sent < nBufLen)
	{
		if (m_NetStatus != NET_CONNECTED) // protect against lost socket
		{
			m_NetStatus = NET_ERROR;
			OnClose(-1);
			sent = -1;
		}
		iSent = CAsyncSocket::Send( (BYTE*)lpBuf+sent, nBufLen-sent, nFlags);
		if (iSent == 0)
		{
			m_RTTYAppDlg->GiveUp();
		}
		if (iSent == SOCKET_ERROR)
		{
			OnClose(-1);			
			m_NetStatus = NET_ERROR;
			status = GetLastError();
			sprintf(str,"Telnet::Send socket error %i Channel %i",status, m_Channel);
			m_RTTYAppDlg->Log(str);
			sent = -1;
			break;  // cause force out of loop 
		}
		else
			sent += iSent;
	}
	return sent;
}



void Telnet::StartSocketThread()
{
	StartSocketConnect(m_lpszHostAddress, m_nHostPort);

}
